<?php
require_once(foodPath::fromRoot("classes_jmysqli.php"));

class foodDB
	{
	public static $connect;
	
	static function Connect()
		{
		if(!is_object(self::$connect))
			{
			self::$connect=@new jmysqli();
			if(self::$connect->connect_errno)
				{
				exit(ADATBAZISHIBASZOVEG_FRONTEND);
				}
			else
				{
				$qy="SET character_set_results = 'utf8', character_set_client = 'utf8', character_set_connection = 'utf8', character_set_database = 'utf8', character_set_server = 'utf8'";
				$st=self::$connect->prepare($qy);
				$qy2="SET NAMES 'utf8' collate ".DBCOLLATION;
				$st2=self::$connect->prepare($qy2);
				if($st && $st2)
					{
                       $st->exec();
					$st2->exec();
					}
				
				}
			}
		return(self::$connect);
        }
        
     public static function setCollate($collate=null)
        {
        $conn=self::Connect();
        if(is_null($collate))
            {
            $collate=DBCOLLATION;
            }
        $qyc="SET NAMES 'utf8' collate ".$collate;;
        $stc=$conn->prepare($qyc);
        $stc->exec();
        }
	}

class foodREQUEST
    {
    public static function check()
        {
        if(isset($_POST))
            {
            array_walk_recursive($_POST,"foodstrip");
            }
        if(isset($_GET))
            {
            array_walk_recursive($_GET,"foodstrip");
            }
        }
    }
    
function foodstrip(&$val)
    {
    $val=strip_tags(trim($val));
    }  
        
abstract class foodLang
    { // ez csak alaposztály!
    
    function __construct()
        {
        $this->init();
        $this->setNapok();
        $this->setHonapok();
        $this->setABC();
        }
    
    function __call($func,$args)
        {
        return call_user_func_array(array("foodString",$func), $args);
        }
    
    abstract public function init();
    abstract public function setNapok();
    abstract public function setHonapok();  
    abstract public function setABC();
    abstract public function getTxtDatum_replace($matches);      
          
    function add($stringfrom,$stringto,$type) 
        { // $s1,$s2,$type
        if(is_null($type))
            {
            $type=foodString::$defaulttype;
            }
        foodString::add($stringfrom,$stringto,$type);
        }    
    }
    
class foodString_base
    {
    public static $strings=array(); // többdimenziós lesz
    public static $strings_reverse=array(); // ez is
    
    public static $defaulttype="string";
    
    public static $types=array();
    
    public static $ONEWAY=1;
    public static $TWOWAYS=2;
    
    public static $inited=false;
    
    public static $langobj=null;
    
    static function init()
        {
        self::addType(self::$defaulttype,self::$TWOWAYS);
        
        $file="class_foodLang_actual.php";
        if(file_exists(foodPath::fromRoot(LANGDIR.foodLanguage::getLangDir().$file)))
            {
            require_once(foodPath::fromRoot(LANGDIR.foodLanguage::getLangDir().$file));
            self::$langobj=new foodLang_actual;
            self::$langobj->init();
            }
        self::$inited=true;
        }
    
    static function forceInit()
        {
        if(!self::$inited)
            {
            self::init();
            }
        }
    
    static function addType($typename,$direction)
        { // $direction: self::$ONEWAY , self::$TWOWAY
        self::$types[$typename]["direction"]=$direction;
        self::$strings[$typename]=array();
        }
    
    static function getDirection($typename)
        {
        return(self::$types[$typename]["direction"]);
        }
    
    static function is_set($type,$string)
        {
        if(isset(self::$strings[$type][foodLanguage::getLang()][base64_encode($string)]))
            {
            return(true);
            }
        return(false);
        }
    
    static function out($string,$type=null)
        {
        self::forceInit();
        
        if(is_null($string))
            {
            trigger_error("foodString::out called with no arguments, considered empty string type string returned empty string", E_NOTICE);
            return("");
            }
            
        if(is_null($type))
            {
            $type=self::$defaulttype;
            }
       
        if(isset(self::$strings[$type][foodLanguage::getLang()][base64_encode($string)]))
            {
            return(self::$strings[$type][foodLanguage::getLang()][base64_encode($string)]);
            }

        return($string);    
        }
     
     static function in($string,$type=null)
        {
        self::forceInit();
        
        if(is_null($string))
            {
            trigger_error("foodString::in called with no arguments, considered empty string type string returned empty string", E_NOTICE);
            return("");
            }
            
        if(is_null($type))
            {
            $type=self::$defaulttype;
            }

        if(isset(self::$strings_reverse[$type][foodLanguage::getLang()][base64_encode($string)]))
            {
            return(self::$strings_reverse[$type][foodLanguage::getLang()][base64_encode($string)]);
            }

        return($string);    
        }
     
    static function add($stringfrom , $stringto , $type=null) // $stringfrom , $stringto , $type
        {
        if(is_null($type))
            {
            $type=self::$defaulttype;
            }

        self::$strings[$type][foodLanguage::getLang()][base64_encode($stringfrom)]=$stringto;
        if(self::getDirection($type)==self::$TWOWAYS)
            {
            self::$strings_reverse[$type][foodLanguage::getLang()][base64_encode($stringto)]=$stringfrom;
            }
        }  
    }


abstract class basetemplate
    {
    public $op;
    public $properties=array();
    
    function __construct($op)
        {
        $this->op=$op;
        }
        
    function __get($name)
        {
        if(isset($this->properties[$name]))
            {
            return($this->properties[$name]);
            }
        return(null);
        }
        
    function __set($name, $value)
        {
        $this->properties[$name] = $value;
        }
        
    abstract public function Show();
    }    

abstract class moduletemplate extends basetemplate
    {
    final public function Show(){}
    abstract public function Display();
    public function Text($text,$align=null,$color=null)
        {
        if(is_null($align))
            {
            $align="left";
            }
        if(is_null($color))
            {
            $color="black";
            }
        ?>
        <div align="<?php echo $align; ?>" style="color:<?php echo $color; ?>; font-weight:bold;"><?php echo $text; ?></div>
       <?php 
        }
    }
 
class emptymoduletemplate extends moduletemplate
    {
    public function Display(){}
    }
 
class foodblank
    {
    function __call($name,$args)
        {
        return(false);
        }
    }
    
class emptytemplate extends basetemplate
    { // pl. setetlapetelBox -ban cserélni a basetemplate-et erre
    public function Show(){}
    }
    
class basetxtmail extends basetemplate
    {
     function Show()
        {
        echo $this->op->uzenet;
        }
    }

    
class baseclass
    {
     public $templatefile;
     public $templateclassname;
     public $finalTemplate=false;
     public $redirectopage="";
     public $templateobject;
     
     function setTemplate($product,$type=null)
        {
        $t=foodFactory::prepareTemplate($product,$type);  
        $this->templatefile=$t->templatefile;
        $this->templateclassname=$t->templateclassname;
        $this->finalTemplate=true;
        }
     
	function Run()
        {
        require_once(foodPath::fromRoot($this->templatefile));
        $cl=$this->templateclassname;
        $this->templateobject = new $cl($this);
        $this->templateobject->Show();
        }
    }    

class moduleclass extends baseclass
    {
    function __call($name,$args)
        {
        if(method_exists($this->templateobject,$name))
            {
            return(call_user_func_array(array($this->templateobject,$name), $args));
            }
        else
            {
            trigger_error("moduleclass: ".$name." method does not exist", E_USER_ERROR);
            return("");
            }
        }
    
    function Run()
        {
        if(is_file(foodPath::fromRoot($this->templatefile)))
            {
            require_once(foodPath::fromRoot($this->templatefile));
            $cl=$this->templateclassname;
            }
        else
            {
            $cl="emptymoduletemplate";
            }
        $this->templateobject = new $cl($this);
        $this->templateobject->Show();
        }
    }
    
class simpleBox extends baseclass
	{	
     public $op;
	function __construct($templatefile,$templateclassname)
		{
         $this->templatefile=$templatefile;
         $this->templateclassname=$templateclassname;
         }
         
     function Run()
        {
        require_once(foodPath::fromRoot($this->templatefile));
        $cl=$this->templateclassname;
        $this->templateobject= new $cl($this->op);
        $this->templateobject->Show();
        }
	}

class foodTemplate extends baseclass
	{
     public $contents;
     function __construct($templatefile,$templateclassname,$contents)
		{
         $this->templatefile=$templatefile;
         $this->templateclassname=$templateclassname;
         $this->contents=$contents;
         }
	}
    
class popupBox extends baseclass
	{
	public $data;
			
	function __construct($file,$templateclassname)
		{
		$this->templatefile=$file;
         $this->templateclassname=$templateclassname;
		$this->data=array();
		$this->data['Nev']=$_GET['Nev'];
		$this->data['md5_nev']=$_GET['md5nev'];
		}
	}
    
 
class prepared
    {
    public $DEFNAME;
    public $file;
    public $classname;
    
    public $templateDEFNAME;
    public $templatefile;
    public $templateclassname;
    
    function __construct($DEFNAME, $file, $classname, $templateDEFNAME, $templatefile, $templateclassname)
        {
        $this->DEFNAME=strtolower($DEFNAME);
        $this->file=$file;
        $this->classname=$classname;
        
        $this->templateDEFNAME=strtolower($templateDEFNAME);
        $this->templatefile=$templatefile;
        $this->templateclassname=$templateclassname;
        }
    }

class foodFactory
    {
    public static $prepared;
    public static $product;
    public static $classname;
    public static $templateclassname;
    
    public static $prefix="";
    public static $DEFDIR;
    public static $DEFNAME;
    
    public static $templateDEFDIR;
    public static $templateDEFNAME;
    
    public static $file;
    public static $templatefile;
    
    public static $pageStatic;
    public static $pageDynamic;
    public static $pageTemplate;
    public static $pageForcelang;
    
    public static $objargs;

    public static function wPage()
        {
        return(new foodPage(get_query_var('pagename')));
        }
        
    public static function isPage($page)
        {
        if(method_exists( "foodPage" , "setpage_".$page))
            {
            return true;
            }
        return false;    
        }
        
    public static function ifPage($page)
        {
        if(method_exists( "foodPage" , "setpage_".$page))
            {
            return(new foodPage($page));
            }
        return(new foodblank);    
        }
        
    public static function iswPage()
        {
        if(method_exists( "foodPage" , "setpage_".get_query_var('name')))
            {
            return true;
            }
        return false;   
        }        
        
    public static function ifwPage()
        {
        if(method_exists( "foodPage" , "setpage_".get_query_var('name')))
            {
            return(new foodPage(get_query_var('name')));
            }
        return(new foodblank);    
        }

    public static function init()
        {
        self::$prepared=false;
        self::$product="";  
        self::$classname="";
        self::$templateclassname="";
        
        self::$prefix="";
        self::$DEFDIR="";
        self::$DEFNAME="";
        self::$file=false;
        self::$templatefile=false;
        
        self::$templateDEFDIR="";
        self::$templateDEFNAME="";
        self::$file=false;
        self::$templatefile=false;
        
        self::$pageStatic=false;
        self::$pageDynamic=false;
        self::$pageTemplate=false;
        self::$pageForcelang=false;
        }
    
    public static function initCreate($args)
        {
        self::$objargs=array();
        $numargs=count($args);
        
        if($numargs<=1)
            {
            return;
            }    
        else
            {
            for($i=0; $i<=$numargs-2; $i++)
                {
                self::$objargs[$i]=$args[$i+1];
                }
            }
        }
    
    public static function simpleBox($product,$op=null,$params=null)
        {
        if(is_null($product))
            {
            trigger_error("foodFactory::simpleBox no product given", E_USER_ERROR);
            }
        $prep=self::prepare($product,pageSTATIC);
        $sbox=self::create($prep);
        $sbox->op=$op;
        if(!is_null($op) && !is_null($params))
            {
            if(is_array($params))
                {
                foreach($params as $propertyName => $value)
                    {
                    $sbox->$propertyName=$value;
                    }
                }
            }
        return($sbox);
        }
        
    public static function runSimpleBox($product,$op=null,$params=null)
        {
        if(is_null($product))
            {
            trigger_error("foodFactory::runSimpleBox no product given", E_USER_ERROR);
            }
        else
            {
            $s=self::simpleBox($product,$op,$params);
            $s->Run();
            return($s);
            }
        }
     
    private static function convertArgs($args)
        {
        if(is_array($args[0]))
            {
            return($args[0]);
            }
        return($args);
        }
     
    public static function box()
        {
        $args=self::convertArgs(func_get_args());
        if(is_null($args[0]))
            {
            trigger_error("foodFactory::box no product given", E_USER_ERROR);
            }
        $args[0]=self::prepare($args[0],pageDYNAMIC);
        return(call_user_func_array(array("self","create"),$args));
        }
    
    public static function runBox()
        {
        $args=self::convertArgs(func_get_args());
        if(is_null($args[0]))
            {
            trigger_error("foodFactory::runBox no product given", E_USER_ERROR);
            }
        else
            {
            $s=self::box($args);
            $s->Run();
            return($s);
            }
        }
    
    public static function addModule()
        {
        $args=self::convertArgs(func_get_args());
        $numargs=count($args);
        if($numargs<1)
            {
            trigger_error("foodFactory::addModule no product given", E_USER_ERROR);
            }
        else
            {
            $product=$args[0];
            if(isset(foodModule::$modules[$product]))
                {
                return(foodModule::$modules[$product]);
                }
            else
                {
                $args[0]=MODULEDIR.$product;
                $realargs=array();
                for($i=0; $i<$numargs && !($args[$i] instanceof foodModule); $i++)
                    {
                    $realargs[$i]=$args[$i];
                    }
                foodModule::$modules[$product]=foodFactory::runBox($realargs);
                foodModule::$modules[$product]->name=$product;
                for($i; $i<$numargs; $i++)
                    {
                    if($args[$i] instanceof foodModule)
                        {
                        foodModule::$modules[$product]->addModule($args[$i]);
                        }
                    }
                return(foodModule::$modules[$product]);
                }
            }
        }
    
    public static function select_subModule(foodModule $module)
        {
        $realargs=array();
        $numargs=func_num_args();
        if($numargs>1)
            {
            $args=func_get_args();
            for($i=1; $i<$numargs; $i++)
                {
                $realargs[$i-1]=$args[$i];
                }
            }
        if(method_exists($module,"subModule"))
            {
            return(call_user_func_array(array($module,"subModule"),$realargs));
            }
        else
            {
            trigger_error("foodFactory::subModule given module does not support submodules (subModule method does not exist)", E_USER_ERROR);
            }
        }
    
    public static function template($product,$contents=array())
        {
        if(is_null($product))
            {
            trigger_error("foodFactory::template no product, no contents given", E_USER_ERROR);
            }
        $prep=self::prepare($product,pageTEMPLATE);
        return(self::create($prep,$contents));
        }
    
    public static function runTemplate($product,$contents)
        {
        $t=self::template($product,$contents);
        $t->Run();
        return($t);
        }
    
    public static function make()
        {
        $args=func_get_args();
        $args[0]=self::prepare($args[0]);
        return(call_user_func_array(array("self","create"),$args));
        }
    
    public static function create()
        {
        $numargs=func_num_args();
        if($numargs<1)
            {
            trigger_error("foodFactory::create prepared object not given", E_USER_ERROR);
            }
            
         $args=func_get_args();
         $prep=$args[0];
         
         if(get_class($prep)!="prepared")
            {
            trigger_error("foodFactory::create given object is not an instance of prepared [product=".self::$product."]", E_USER_ERROR);
            }
         
         self::initCreate($args);
        
        $defname=$prep->DEFNAME;
        if(is_file(foodPath::fromRoot($prep->file)))
            {
            require_once(foodPath::fromRoot($prep->file));
            }
        else
            {
            trigger_error("foodFactory::create prepared::file not exists [file=".$prep->file."]", E_USER_ERROR);
            }
            
        if($defname=="box")
            {
            $obj=new simpleBox($prep->file,$prep->classname);
            return($obj);
            }
        
        if($defname=="template")
            {
            $obj=new foodTemplate($prep->file,$prep->classname,$args[1]);
            return($obj);
            }

        $templatefile=$prep->templatefile;
        $classname=$prep->classname;
        
        $cl = new ReflectionClass($prep->classname);
        $obj = $cl->newInstanceArgs(self::$objargs);

        if(!$obj->finalTemplate)
            {
            $obj->templatefile=$prep->templatefile;
            $obj->templateclassname=$prep->templateclassname;
            }
        return($obj);
        }
    
    public static function getPrepared()
        {
        self::$prepared=true;
        return(new prepared(self::$DEFNAME, self::$file, self::$classname, self::$templateDEFNAME, self::$templatefile, self::$templateclassname));
        }
    
    public static function setProduct($args)
        {
        self::init();
        $numargs=count($args);
        if($numargs==0)
            {
            trigger_error("foodFactory::setProduct needs 1 or 2 arguments.", E_USER_ERROR);
            }
        $product=$args[0];
        if($numargs==2)
            {
            $type=$args[1];
            self::$pageStatic= ($type & pageSTATIC) > 0 ? true : false;
            self::$pageDynamic= ($type & pageDYNAMIC) > 0 ? true : false;
            self::$pageTemplate= ($type & pageTEMPLATE) > 0 ? true : false;
            self::$pageForcelang= ($type & pageFORCELANG) > 0 ? true : false;
            if( (self::$pageStatic && self::$pageDynamic) || self::$pageTemplate)
                {
                self::$pageStatic=false;
                self::$pageDynamic=false;
                }
            }
        $sub=strrpos($product,'/'); // $sub = az utolsó "/" pozíciója product-ban
         if($sub!==false) // ha volt benne "/"
            {
            self::$prefix=substr($product,0,$sub+1); // self::$prefix = az utolsó "/" és az előtte levő rész
            self::$product=substr($product,$sub+1,strlen($product)-$sub-1); // self::$product = a maradék ( a filenév kiterjesztés és egyebek nélkül )
            }
         else
            {
            self::$product=$product; // különben csak filenév volt és az lesz self::$product ( a filenév kiterjesztés nélkül )
            }
        }

    public static function prepareTemplate()
        {
        self::setProduct(func_get_args());
        $langdir=foodLanguage::getLangDir();
        
         if(self::$pageForcelang)
            {
            if(self::anyfile("box",$langdir,"template"))
                {
                return(self::getPrepared());
                }
            trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product."].", E_USER_WARNING);
            return(false);
            }
         else
            {
            if(self::anyfile("box",$langdir,"template"))
                {
                return(self::getPrepared());
                }
            else
                {
                if(self::anyfile("box","","template"))
                    {
                    return(self::getPrepared());
                    }
                 trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product."].", E_USER_WARNING);
                 return(false);
                 }
            }
        
        }
    
    public static function prepare()
        { // be kell állítania: a file, amit include-olni kell ($file), a létrehozandó objektum class nevét ($classname), és ha van akkor a class-hoz tartozó (csak ehhez a típushoz lehet) templatefile nevét ($templatefile)
         
        self::setProduct(func_get_args());
         
        $langdir=foodLanguage::getLangDir();
   
        if(foodLanguage::$ISDEFAULT || self::$pageForcelang)
            {
            if(self::$pageStatic)
                {
                if(self::anyfile("box",$langdir))
                    {
                    return(self::getPrepared());
                    }
                trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product." , pageStatic || pageForcelang ]", E_USER_WARNING);
                return(false);
                }
             
            if(self::$pageDynamic)
                {
                if(self::anyfile("class",$langdir))
                    {
                    self::anyfile("box",$langdir,"template");
                    return(self::getPrepared());
                    }
                trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product." , pageDynamic || pageForcelang]", E_USER_WARNING);
                return(false);
                }
            
            if(self::$pageTemplate)
                {
                if(self::anyfile("template",$langdir))
                    {
                    return(self::getPrepared());
                    }
                trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product." , pageDynamic || pageTemplate]", E_USER_WARNING);
                return(false);
                }
             
             if(self::anyfile("box",$langdir))
                {
                return(self::getPrepared());
                }
              else
                {
                if(self::anyfile("class",$langdir))
                    {
                    self::anyfile("box",$langdir,"template");
                    return(self::getPrepared());
                    }
                trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product."]", E_USER_WARNING);
                return(false);
                }
             
             }
         else
            {
            if(self::$pageStatic)
                {
                if(self::anyfile("box",$langdir))
                    {
                    return(self::getPrepared());
                    }
                else
                    {
                    if(self::anyfile("box",""))
                        {
                        return(self::getPrepared());
                        }
                    }
                trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product."]", E_USER_WARNING);
                return(false);
                }
             
            if(self::$pageDynamic)
                {
                if(self::anyfile("class",$langdir))
                    {
                    self::anyfile("box",$langdir,"template");
                    return(self::getPrepared());
                    }
                else
                    {
                    if(self::anyfile("class",""))
                        {
                        if(self::anyfile("box",$langdir,"template"))
                            {
                            return(self::getPrepared());
                            }
                        self::anyfile("box","","template");
                        return(self::getPrepared());
                        }
                     trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product."]", E_USER_WARNING);
                     return(false);
                    }
                }
            
            if(self::$pageTemplate)
                {
                if(self::anyfile("template",$langdir))
                    {
                    return(self::getPrepared());
                    }
                else
                    {
                    if(self::anyfile("template",""))
                        {
                        return(self::getPrepared());
                        }
                    }
                trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product."]", E_USER_WARNING);
                return(false);
                }
              
              
              if(self::anyfile("box",$langdir))
                {
                return(self::getPrepared());
                }
              else
                {
                if(self::anyfile("box",""))
                    {
                    return(self::getPrepared());
                    }
                else
                    {
                    if(self::anyfile("class",$langdir))
                        {
                        self::anyfile("box",$langdir,"template");
                        return(self::getPrepared());
                        }
                    else
                        {
                        if(self::anyfile("class",""))
                            {
                            if(self::anyfile("box",$langdir,"template"))
                                {
                                return(self::getPrepared());
                                }
                            self::anyfile("box","","template");
                            return(self::getPrepared());
                            }
                         trigger_error("foodFactory::prepareTemplate cannot prepare [product=".self::$product."]", E_USER_WARNING);
                         return(false);
                        }
                    }
                }
                
             }
        }

        
     public static function filelower($defdir,$defname,$langdir) 
        {
        return($defdir.self::$prefix.$langdir.foodConstants::$productprepost[strtolower($defname)]["file"]["prefix"].self::$product.foodConstants::$productprepost[strtolower($defname)]["file"]["postfix"]);
        }
        
     public static function fileupper($defdir,$defname,$langdir) 
        {
        return($defdir.self::$prefix.$langdir.foodConstants::$productprepost[strtoupper($defname)]["file"]["prefix"].self::$product.foodConstants::$productprepost[strtoupper($defname)]["file"]["postfix"]);
        }
        
     public static function anyfile($defname,$langdir,$typeprefix=null)
        {
        if(is_null($defname) || is_null($langdir))
            {
            trigger_error("foodFactory::anyfile defname or langdir not given", E_USER_ERROR);
            }
        if(!is_null($typeprefix))
            {
            $typeprefix="template";
            $defdir=DDIR;
            }
         else
            {
            $defdir=foodConstants::$productdirs[$defname];
            }
        
        $filelower=self::filelower($defdir,$defname,$langdir);
        $fileupper=self::fileupper($defdir,$defname,$langdir);
        
        $thisfile=$typeprefix."file";
        $thisclassname=$typeprefix."classname";
        $thisDEFNAME=$typeprefix."DEFNAME";
        $thisDEFDIR=$typeprefix."DEFDIR";
        
        if(is_file(foodPath::fromRoot($filelower)))
            {
            $file=$filelower;
            self::$$thisDEFNAME=strtolower($defname);
            }
         else
            {
            if(is_file(foodPath::fromRoot($fileupper)))
                {
                $file=$fileupper;
                self::$$thisDEFNAME=strtoupper($defname);
                }
            else
                {
                return(false);
                }
            }

         self::$$thisDEFDIR=foodConstants::$productdirs[self::$$thisDEFNAME];
         self::$$thisfile=$file;
         self::$$thisclassname=foodConstants::$productprepost[self::$$thisDEFNAME]["classname"]["prefix"].self::$product.foodConstants::$productprepost[self::$$thisDEFNAME]["classname"]["postfix"];
         return(true);
        }
        
    }

class foodPage_base
	{
	public $page;
	public $template;
	public $content;
	//public $title;
    //public $maintitle="";
	
	function __construct($foodpage=null)
		{
        date_default_timezone_set(FOODTIMEZONE);
        if(!is_null($foodpage))
            {
            $_GET['foodpage']=$foodpage;
            }
          food::$page=$this;
         
		if(!isset($_GET['foodpage']))
			{
			$_GET['foodpage']=foodString::page_out('fooldal');
			}
		else
			{
			if($_GET['foodpage']=='')
				{
				$_GET['foodpage']=foodString::page_out('fooldal');
				}
			}
		
		$tpage=str_replace('-','_',foodString::page_in($_GET['foodpage']));
		$this->name=$tpage;
        
		if(method_exists($this,'setpage_'.$tpage))
			{
			$func='setpage_'.$tpage;
			$this->$func(foodString::page_in($_GET['foodpage']));
			}
		else
			{
			$this->setpage_fooldal('fooldal');
			}
		}
	
    /* Ez itt minek volt????
     function checkClassFile($file)
        {
        }
     */
	
	function Init($page,$template,$contents)
		{
		$this->page=$page;
         $prep=foodFactory::prepare($template,pageTEMPLATE);
         if($prep)
            {
            $this->template=foodFactory::create($prep,$contents);
            }
		$this->content=$contents;
		}

    
	function Run()
        {
        $this->template->Run();
        }
	
	} 
    

class foodUser
	{

     public static $userAddress=array();
     public static $userAddressAll=array();
     public static $kollegak=array();
	
    static function IsLogged()
        {
        if(isset($_SESSION["foodUser"]["logged"]))
            {
            if($_SESSION["foodUser"]["logged"]===true)
                {
                return(true);
                }
            }
        return(false);
        }
    
    	static function Login($user,$pass)
		{
		$conn=foodDB::Connect();
		$_SESSION["foodUser"]["logged"]=false;
        
         if($user!="" && $pass!="" && !isset($_GET['act']))
            {
            if(EMAILLOGIN && foodString::regex($user,foodConstants::$MAILPATTERN)=="OK")
                {
                $qyuser="select f.idlogin, f.Statusz, f.jelszo, f.Email, f.loginNev, fc.id from felhasznalok f,felhasznalok_cimek fc where f.idlogin=fc.idlogin and f.Email=? order by f.loginNev";
                }
             else
                {
             $qyuser="select f.idlogin, f.Statusz, f.jelszo, f.Email, fc.loginNev, fc.id from felhasznalok f, felhasznalok_cimek fc where f.idlogin=fc.idlogin and fc.loginNev=? order by loginNev";
                }
             $stuser = $conn->prepare($qyuser);
             if(!$stuser)
                {
                exit(ADATBAZISHIBASZOVEG_FRONTEND);
                }
                
             $stuser->bind_param('s',$user);
             $stuser->exec();
             $nur=$stuser->num_rows();
             
             if($nur==0)
                {
                return("nemtemp");
                }
             
             $okuser=false;

             while($soruser=$stuser->fetch_assoc())
                {
                if($soruser["jelszo"]==$pass || $soruser["jelszo"]==md5($pass))
                    {
                    $okuser=$soruser;
                    break;
                    }
                }
                
             if(!$okuser)
                {
                return("nemtemp");
                }
         
             $_SESSION["foodUser"]["userData"]=$okuser;
             if($_SESSION["foodUser"]["userData"]["Statusz"])
                {
                $_SESSION["foodUser"]["logged"]=true;
                self::setUserData();
                self::setAddresses();
               
                if(!MULTIADDRESS)
                    {
                    reset(self::$userAddress);
                    list($id,$cim)=each(self::$userAddress);
                    self::setAktualisCim($id);
                    }
                 else
                    {
                    self::setAktualisCim($okuser["id"]);
                    }
                }
            
             return("nemtemp");
			}
		else
			{ // url-es login
             if(!AUTOLOGINNEV)
                {
                 //$qyuser="select idlogin, temp, Statusz, tlogin from felhasznalok where tlogin=?";
                 $qyuser="select f.idlogin, fc.temp, fc.tlogin, f.Statusz, f.jelszo, fc.loginNev, fc.id from felhasznalok f, felhasznalok_cimek fc where f.idlogin=fc.idlogin and fc.tlogin=?";
                $stuser = $conn->prepare($qyuser);
                if(!$stuser)
                    {
                    exit(ADATBAZISHIBASZOVEG_FRONTEND);
                    }
                else
                    {
                    $stuser->bind_param('s',$user);
                    $stuser->exec();
                    $nur=$stuser->num_rows();
                    if($nur>0)
                        {
                        $okuser=$stuser->fetch_assoc();
                        $_SESSION["foodUser"]["userData"]=$okuser;
                        if($_SESSION["foodUser"]["userData"]['temp']==0)
                            {
                            $_SESSION["foodUser"]["logged"]=false;
                            return("temp");
                            }
                        else
                            {
                            $_SESSION["foodUser"]["logged"]=true;
                               self::setUserData();
                               self::setAddresses();
                               
                               if(!MULTIADDRESS )
                                    {
                                    reset(self::$userAddress);
                                    list($id,$cim)=each(self::$userAddress);
                                    self::setAktualisCim($id);
                                    }
                              else
                                {
                                self::setAktualisCim(($okuser["id"]));
                                }       
                            return("nemtemp");
                            }
                        }
                    return("nemtemp");
                    }
                }
            }
            
		}
    
    
    static function getuserAddresses()    
        { 
        if(empty(self::$userAddress))
            {
            self::setAddresses();
            }
        return(self::$userAddress);
        }
	
    static function getuserAddressesAll()    
        { 
        if(empty(self::$userAddressAll))
            {
            self::setAddresses();
            }
        return(self::$userAddressAll);
        }
    
    static function getAddressById($id)
        {
        $cimek=self::getuserAddresses();
        if(isset($cimek[$id]))
            {
            return($cimek[$id]);
            }
        return(false);
        }
        
    static function getAddressByIdAll($id)
        {
        $cimek=self::getuserAddressesAll();
        if(isset($cimek[$id]))
            {
            return($cimek[$id]);
            }
        return(false);
        }
    
    static function getAddressByLoginNev($loginNev)
        {
        $cimek=self::getuserAddresses();
        foreach($cimek as $id => $cim)
            {
            if($cim["loginNev"]==$loginNev)
                {
                return($cimek[$id]);
                }
            }
        return(false);    
        }
    
    static function getAddressByLoginNevAll($loginNev)
        {
        $cimek=self::getuserAddressesAll();
        foreach($cimek as $id => $cim)
            {
            if($cim["loginNev"]==$loginNev)
                {
                return($cimek[$id]);
                }
            }
        return(false);
        }
    
    static function getaktualiscim()    
        { // ezt megnézni... !!!!
        return($_SESSION["kosar"]["aktualiscim"]);
        }
    
    static function getkollegak()    
        {
        if(empty(self::$kollegak))
            {
            self::setkollegak();
            }
        return(self::$kollegak);
        }
    
    static function getuserDataAttr($attr)
        {
        return($_SESSION["foodUser"]["userData"][$attr]);
        }
    
    static function isMainUser()
        {
        if(self::getuserDataAttr("loginNev")==self::getuserData("loginNev"))
            {
            return(true);
            }
        return(false);
        }
    
    static function getuserData($attr)
        {
        //return($_SESSION["foodUser"]["userData"][$attr]);
        
        if(in_array($attr,array("jelszo","Statusz","Email","Newsletter","Kedvezmeny","emlekezteto", "emlekezteto_ok", "emlekezteto_uid", "emlekezteto_limit")))
            {
            return($_SESSION["foodUser"]["userData"][$attr]);
            }
        else
            {
            return(self::getcimData($attr));
            }
        }
    
    static function getcimData($attr)
        {
        return($_SESSION["kosar"]["aktualiscim"][$attr]);
        }
    
    static function setAktualisCim($id)
        {
        $cimek=self::getuserAddresses();
        if(isset($cimek[$id]))
            {
            $_SESSION["kosar"]["aktualiscim"]=$cimek[$id];
            }
        }

    static function resetAktualisCim()
        {
        foodUser::setUserData();
        foodUser::setAddresses();
        $cimek=self::getuserAddresses();
        list($id,$cim)=each($cimek);
        self::setAktualisCim($id);
        }        
     
	
    static function setUserData()
        {
        if($_SESSION["foodUser"]["logged"] && isset($_SESSION["foodUser"]["userData"]["idlogin"]))
            {
            $conn=foodDB::Connect();
            $qyuser="select idlogin,loginNev,jelszo,Nev,UNev,Varos,Iszam,Utca,Hazszam, Kaputel, Email, Telefon, Fax, Szamnev, Szamiszam, Szamvaros, Szamutca, Szamhazszam, Megjegy, Statusz, Varos2, Kedvezmeny, Newsletter, lang, otszaz, temp, Jarat, idobelyeg, utolsoosszeg, utolsohet, tlogin, emlekezteto, emlekezteto_ok, emlekezteto_uid, emlekezteto_limit, 	Szamadoszam, Szamlaszam from felhasznalok where idlogin=?";
			$stuser = $conn->prepare($qyuser);
			if(!$stuser)
				{
				exit(ADATBAZISHIBASZOVEG_FRONTEND);
				}
			else
				{
				$stuser->bind_param('i',$_SESSION["foodUser"]["userData"]["idlogin"]);
				$stuser->exec();
				$nur=$stuser->num_rows();
				if($nur>0)
					{
					$_SESSION["foodUser"]["userData"]=$stuser->fetch_assoc();
					}
                 }
            }
        }
    
    static function setUserSessionData($key,$value)
        {
        $_SESSION["foodUser"]["userData"][$key]=$value;
        }
        
    static function setAddresses()
        { // ha be van jelentkezve, veszi az összes címét. 
        if(self::IsLogged())
            {
            $conn=foodDB::Connect();
            $qyusercim="select fc.id,fc.idlogin,fc.loginNev,fc.Nev,fc.UNev,fc.Varos,fc.Iszam,fc.Utca,fc.Hazszam, fc.Kaputel, f.Email, fc.Telefon, fc.Fax, fc.Szamnev, fc.Szamiszam, fc.Szamvaros, fc.Szamutca, fc.Szamhazszam, fc.Megjegy, fc.Kedvezmeny, fc.Newsletter, fc.Jarat, fc.cimmod, fc.ujreg, fc.temp, fc.tlogin, 	fc.Szamadoszam, fc.Szamlaszam from felhasznalok_cimek fc, felhasznalok f where fc.idlogin=f.idlogin and fc.idlogin=?";
            $stusercim = $conn->prepare($qyusercim);
            if(!$stusercim)
                {
                exit(ADATBAZISHIBASZOVEG_FRONTEND." setAddresses");
                }
            else
                {
                $stusercim->bind_param('i',$_SESSION["foodUser"]["userData"]['idlogin']);
                $stusercim->exec();
                $nur=$stusercim->num_rows();
                if($nur>0)
                    {
                    while($soraddress=$stusercim->fetch_assoc())
                        {
                        if($soraddress["cimmod"]==0)
                            {
                            self::$userAddress[$soraddress['id']]=$soraddress;
                            self::$userAddress[$soraddress['id']]['Cim']=$soraddress['Iszam'].' '.$soraddress['Varos'].' '.$soraddress['Utca'].' '.$soraddress['Hazszam'];
                            }
                         self::$userAddressAll[$soraddress['id']]=$soraddress;
                         self::$userAddressAll[$soraddress['id']]['Cim']=$soraddress['Iszam'].' '.$soraddress['Varos'].' '.$soraddress['Utca'].' '.$soraddress['Hazszam'];   
                        }
                    }
                }
            }
        }
     
     static function setkollegak()
        {
        if(COLLEAGUES && self::IsLogged())
            {
            $conn=foodDB::Connect();
            
            $qykoll = "SELECT IFNULL( fa.id, 0 ) AS id, IFNULL( fa.Nev, fc.Nev ) AS KollegaNev, fc.Nev, fc.Iszam, fc.Varos, fc.Utca, fc.Hazszam, fc.loginNev
            FROM felhasznalok_cimek fc
            LEFT OUTER JOIN felhasznalok_al fa ON fa.loginNev = fc.loginNev
            WHERE fc.idlogin =?
            ORDER BY fc.Iszam, fc.Varos, fc.Utca, fc.Hazszam, fa.Nev";
            
            $stkoll = $conn->prepare($qykoll);
            if(!$stkoll)
                {
                exit(ADATBAZISHIBASZOVEG_FRONTEND);
                }
            else
                {
                $stkoll->bind_param('i',$_SESSION['foodUser']["userData"]['idlogin']);
                $stkoll->exec();
                while($sorkoll=$stkoll->fetch_assoc())
                    {
                    self::$kollegak[$sorkoll['loginNev']][$sorkoll['id']]=$sorkoll;
                    self::$kollegak[$sorkoll['loginNev']][$sorkoll['id']]['Cim']=$sorkoll['Nev'].' '.$sorkoll['Iszam'].' '.$sorkoll['Varos'].' '.$sorkoll['Utca'].' '.$sorkoll['Hazszam'];
                    if(!isset(self::$kollegak[$sorkoll['loginNev']][0]))
                        {
                        $sorkoll["KollegaNev"]=$sorkoll["Nev"];
                        $sorkoll["id"]=0;
                        self::$kollegak[$sorkoll['loginNev']][0]=$sorkoll;
                        self::$kollegak[$sorkoll['loginNev']][0]['Cim']=$sorkoll['Nev'].' '.$sorkoll['Iszam'].' '.$sorkoll['Varos'].' '.$sorkoll['Utca'].' '.$sorkoll['Hazszam'];
                        }
                    }
                if(!empty(self::$kollegak))
                    {
                    foreach(self::$kollegak as $loginNev => &$koll)
                        {
                        ksort($koll);
                        }
                    unset($koll);
                    }
                }
            }
        }
	}
     
require_once(foodPath::fromRoot("class_foodPage.php"));    
?>