<?php
require_once("BASECLASSES.php");

class foodString extends foodString_base
    {
    public static $foodStringInited=false;
    static function foodStringInit()
        {
        self::addType("page",self::$TWOWAYS);
        self::addType("qstring",self::$TWOWAYS);
        self::addType("file",self::$ONEWAY);
        self::addType("regex",self::$ONEWAY);
        self::addType("owstr",self::$ONEWAY);
        if(!self::$inited)
            {
            self::init();
            }
        self::addRegex(foodConstants::$MAILPATTERN,"OK");
        self::$foodStringInited=true;
        }
    
    static function forcefoodStringInit()
        {
        if(!self::$foodStringInited)
            {
            self::foodStringInit();
            }
        }

    static function regex($string,$pattern)
        {
        self::forcefoodStringInit();
        
        if(self::is_set("regex",$pattern))
            {
            $ret=preg_replace($pattern,self::$strings["regex"][foodLanguage::getLang()][base64_encode($pattern)],$string);
            return($ret);
            }
            
        return($string);
        }
    

      static function owstr($string)
        {
        self::forcefoodStringInit();
        
        return(self::out($string,"owstr"));   
        }
     
     
     static function page_out($string)
        {
        self::forcefoodStringInit();
        
        return(self::out($string,"page"));
        }    
        
    static function fullPage($string)
        {
        return(FULLURL.self::page_out($string));
        }
        
    static function page_in($string)
        {
        self::forcefoodStringInit();
        
        return(self::in($string,"page"));
        }
    
     static function qstring_out($string)
        {
        self::forcefoodStringInit();
        
        return(self::out($string,"qstring"));
        }
    
    
    static function qstring_in($string)
        {
        self::forcefoodStringInit();
        
        return(self::in($string,"qstring"));
        }
    
    static function file($string)
        {
        self::forcefoodStringInit();
        
        if(self::is_set("file",$string))
            {
            return(self::out($string,"file"));
            }
        else
            {
            $prefix="";
             $sub=strrpos($string,'/'); 
             if($sub!==false) 
                {
                $prefix=substr($string,0,$sub+1); 
                $file=substr($string,$sub+1,strlen($string)-$sub-1); 
                }
             else
                {
                $file=$string; 
                }
            if(is_file($prefix.foodLanguage::getLang().$file))
                {
                return($prefix.foodLanguage::getLang().$file);
                }
            }

        return($string);
        }
    
    static function fullUrl($string)
        {
        self::forcefoodStringInit();
       /*
        if(isset(self::$files[foodLanguage::getLang()][base64_encode($string)]))
            {
            return(FOODSITE.self::$files[foodLanguage::getLang()][base64_encode($string)]);
            }
        */
        return(FOODSITE.self::file($string));
        }
    
     static function addString($s1,$s2)
        {
        self::add($s1,$s2);
        }
    
     static function addOWString($s1,$s2)
        {
        self::add($s1,$s2,"owstr");
        }
    
    static function addPage($s1,$s2)
        {
        self::add($s1,$s2,"page");
        }
    
    static function addQstring($s1,$s2)
        {
        self::add($s1,$s2,"qstring");
        }
        
    static function addRegex($pattern,$replace)
        {
        self::add($pattern,$replace,"regex");
        }
        
    static function addFile($f1,$f2)
        {
         $prefix="";
         $sub=strrpos($f1,'/'); // $sub = az utolsó "/" pozíciója f1-ben
         if($sub!==false) // ha volt benne "/"
            {
            $prefix=substr($f1,0,$sub+1); // prefix = az utolsó "/" és az előtte levő rész
            $file=substr($f1,$sub+1,strlen($f1)-$sub-1); // $f1 = a maradék ( a filenév kiterjesztés és egyebek nélkül )
            }
         else
            {
            $file=$f1; // különben csak filenév volt és az lesz $file ( a filenév kiterjesztés nélkül )
            }
        
        self::add($f1,$prefix.foodLanguage::getLangDir().$f2,"file");
        }
    
    static function addPath($f1,$f2)
        {
        self::add($f1,$f2,"file");
        }
        
        
    static function getTxtDatum($datum)
        {
        if(foodDatum::check($datum))
            {
            $parts=explode('-',$datum);
            if(checkdate($parts[1],$parts[2],$parts[0]))
                {
                return(preg_replace_callback("#({\d}4)-({\d}2)-({\d}2)#",array(self::$langobj,"getTxtDatum_replace"),$datum));
                }
            }
        }
        
     static function urlChar($ch)
        {
        return(htmlspecialchars($ch));
        }
        
    }

?>