<?php 
require_once("class_basketWeekFoodDisplay.php");
require_once("class_basketFoodDisplay.php");

class foodDisCounter
    {
    public static $alapkedvezmeny;
    public static $elemek=array("normal" => array(), "szazalek" => array(), "ertek" => array());
    public static $vegosszeg=0;
    public static $reszosszegek=array();
    public static $lastadd=array("tipus" => 0, "ertek" => 0);
    
    
    public static function alap($alap)
        {
        self::$alapkedvezmeny=$alap;
        }
    
    public static function reset()
        {
        self::$vegosszeg=0;
        self::resetelemek();
        self::$reszosszegek=array();
        }
    
    public static function resetelemek()
        {
        self::$elemek=array("normal" => array(), "szazalek" => array(), "ertek" => array());
        }
    
    public static function reszosszeg()
        {
        $osszeg=self::calc();
        self::$reszosszegek[]=$osszeg;
        self::resetelemek();
        return($osszeg);
        }
    
    public static function calc()
        {
        $osszeg=0;
        $osszeg+=array_sum(self::$elemek["normal"]);
        foreach(self::$elemek["szazalek"] as $elem)
            {
            $osszeg+=round(self::partsum($elem["arak"])*((100-$elem["mertek"])/100));
            }
        $sum=0;    
        foreach(self::$elemek["ertek"] as $elem)
            {
            foreach($elem["arak"] as $ar)
                {
                $reszar=$ar["ar"]-$ar["db"]*$elem["mertek"];
                if($reszar<0)
                    {
                    $reszar=0;
                    }
                $sum+=$reszar;
                }
            }
        $osszeg+=$sum;
        return($osszeg);
        }
        
     public static function partsum($arak)
        {
        $resz=0;
        foreach($arak as $ar)
            {
            $resz+=$ar["ar"];
            }
        return($resz);
        }
     
    public static function add($etel,$tipus=null,$ertek=null)
        {
        if(is_null($tipus) && is_null($ertek))
            {
            if(!foodModule::ifmodule("kedvezmeny_module")->process($etel))
                {
                self::process($etel);
                }
            }
        else
            {
            self::process($etel,$tipus,$ertek);
            }
        }
        
    public static function process($etel,$tipus=null,$ertek=null)
        {
        if(is_null($tipus) && is_null($ertek))
            {
            self::setlast(0,0);
            if(self::$alapkedvezmeny>0)
                {
                $added=false;
                foreach(self::$elemek["szazalek"] as &$elem)
                    {
                    if($elem["mertek"]==self::$alapkedvezmeny)
                        {
                        $elem["arak"][]=array("ar" => $etel->getSum(), "db" => $etel->getDB());
                        $added=true;
                        }
                    }
                unset($elem);
                if(!$added)
                    {
                    self::$elemek["szazalek"][]=array(
                            "mertek" => self::$alapkedvezmeny,
                            "arak" => array(
                                            array("ar" => $etel->getSum(), "db" => $etel->getDB())
                                            )
                                                      );
                    }
                self::setlast(1,self::$alapkedvezmeny);
                }
            else
                {
                self::$elemek["normal"][]=$etel->getSum();
                }
            }
        else
            {
            if($tipus==0)
                {
                self::$elemek["normal"][]=$etel->getSum();
                }
            else
                {
                if($tipus==1)
                    {
                    $added=false;
                    foreach(self::$elemek["szazalek"] as &$elem)
                        {
                        if($elem["mertek"]==$ertek)
                            {
                            $elem["arak"][]=array("ar" => $etel->getSum(), "db" => $etel->getDB());
                            $added=true;
                            }
                        }
                    unset($elem);
                    if(!$added)
                        {
                        self::$elemek["szazalek"][]=array(
                                    "mertek" => $ertek,
                                    "arak" => array(
                                                array("ar" => $etel->getSum(), "db" => $etel->getDB())
                                                    )
                                                        );
                                                        
                        }
                    self::setlast(1,$ertek);
                    }
                else
                    {
                    if($tipus==2)
                        {
                        $added=false;
                        foreach(self::$elemek["ertek"] as &$elem)
                            {
                            if($elem["mertek"]==$ertek)
                                {
                                $elem["arak"][]=array("ar" => $etel->getSum(), "db" => $etel->getDB());
                                $added=true;
                                }
                            }
                        unset($elem);
                        if(!$added)
                            {
                            self::$elemek["ertek"][]=array(
                                "mertek" => $ertek,
                                "arak" => array(
                                                array("ar" => $etel->getSum(), "db" => $etel->getDB())
                                                )
                                                            );
                            }
                        self::setlast(2,$ertek);
                        }
                    }
                }
            }
        }
     
    public static function setlast($tipus,$ertek)
        {
        self::$lastadd=array("tipus" => $tipus, "ertek" => $ertek);
        }
    
    public static function getlast()
        {
        return(self::$lastadd);
        }
    
    public static function getar($etel)
        {
        if(self::$alapkedvezmeny>0)
            {
            return(round($etel->getSum()*((100-self::$alapkedvezmeny)/100)));
            }
        else
            {
            return($etel->getSum());
            }
        }
    }

class foodBasket
    {
    public $nev="";
    public $aktualiscim=array();
    public $aktualisetlap=null;
    
    public $rendeles=array();
    public $hetirendeles=array();
    
    public $mail=array();
    public $rendelid=array();
    
    public $sum=0;
    public $db=0;
    public $allsum;
    public $alldb=0;
    public $hetisum=0;
    public $hetidb=0;
    
    public $addok=false;
    
    public $etlapsorok;
    public $kategoriasorok;
    
    public $buffer="";
    
    public $korabbi;
    public $kosarszoveg="";
    public $Kedvezmeny=0;
    public $kosarmuvelet;
    public $datum="";
public $ido="";
    public $messages=array();
    
    public $lastkedvezmeny=null;
    
    function __construct($nev)
        {
        $this->nev=$nev;
        $this->kosarmuvelet=foodFactory::box("ajax/kosarmuvelet",$this,array());
        if($this->nev=="rendeles" || $this->nev=="lemondas")
            {
            $this->Kedvezmeny=foodUser::getuserData("Kedvezmeny");
            foodDisCounter::alap($this->Kedvezmeny);
            $this->setAktualisCim(foodUser::getaktualiscim());
            }
        $this->setKategoriasorok();
        }

    function setAktualisCim($aktualiscim)
        {
        $this->aktualiscim=$aktualiscim;
        }
        
    function setKategoriasorok() 
        {
        $conn=foodDB::Connect();
        
        $qy="select kat, kat2, descr from kategoria where lang=?";
        $st=$conn->prepare($qy);
        if(!$st)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
         else
            {
            $st->bind_param("s",foodLanguage::getLang());
            $st->exec();
            while($sor=$st->fetch_assoc())
                {
                $this->kategoriasorok[$sor['kat']]=$sor;
                }
            }
        }
  

    function genrendelid()
        {
        $aktualiscim=foodUser::getaktualiscim();
        $this->rendelid["datepart"]=date("YmdHis");
        if(!empty($aktualiscim))
            {
            if(foodUser::getuserData("temp")!=1)
                {
                $this->rendelid["userpart"]=$aktualiscim["loginNev"];
                }
            else
                {
                $this->rendelid["userpart"]=foodUser::getuserData("tlogin");
                }
            }
        else
            {
            $this->rendelid["userpart"]=uniqid("temp_",true);
            }
        $this->rendelid["rendelid"]=$this->rendelid["datepart"].'_'.$this->rendelid["userpart"];    
        }
    
    function getrendelid()
        {
        if(isset($this->rendelid["rendelid"]))
            {
            return($this->rendelid["rendelid"]);
            }
        return(false);
        }
    
    function setrendelid($rendelid)
        {
        $this->rendelid["rendelid"]=$rendelid;
        }
    
    
    

    function emptyBasket()
        {
        foreach($this->rendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $datumnev => $datum)
                    {
                    $datum->emptyDay();
                    unset($this->rendeles[$evneve][$hetneve][$datumnev]);
                    }
                }
            }
            
        foreach($this->hetirendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $kategorianev => $kategoria)
                    {
                    unset($this->hetirendeles[$evneve][$hetneve][$kategorianev]);
                    }
                }
            }
            
        $this->rendeles=array();
        $this->hetirendeles=array();
        $this->db=0;
        $this->sum=0;
        }

    function isEmpty()
        {
        if($this->getAllDB()==0)
            {
            return(true);
            }
        else
            {
            return(false);
            }
        }
 
    function rendez() 
        {// hetirendeles: ev,het szerint rendezve, rendeles: ev,het,datum szerint rendezve
        ksort($this->hetirendeles);
        foreach($this->hetirendeles as $evneve => $ev)
            {
             ksort($this->hetirendeles[$evneve]);
            }
        ksort($this->rendeles);
        foreach($this->rendeles as $evneve => $ev)
            {
             ksort($this->rendeles[$evneve]);
            }
        foreach($this->rendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                ksort($this->rendeles[$evneve][$hetneve]);
                }
            }
        }

    function darabolas() 
        {// hetirendeles-nél a kategoria objektumokhoz (foodBasketWeekFood)  , rendeles-nél a datum objektumokhoz (foodBasketFood) létrehozza a kollegak tömböt, ami annyi elemű, mint amennyi db "étel" van benne
         foreach($this->hetirendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $kategorianev => $kategoria)
                    {
                    $kategoria->darabolas();
                    }
                }
            }
        foreach($this->rendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $datumnev => $datum)
                    {
                    $datum->darabolas();
                    }
                }
            }
        }
     
  

  
    function plusz($etelid,$n) 
        {// adott datum objektumhoz (foodBasketDay) (etelid alapján: etelid = [kategoriakod-eeee-hh-nn]) (foodBasketFood) hozzáad $n darabot
        $datum=$this->etlapsorok[$etelid]['datum'];
        $kategorianev=$this->etlapsorok[$etelid]['Kategoria'];
        if(isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]))
            { // ha van ilyen dátumú,kategóriájú foodBasketFood
            $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]->plusz($n); // hívja a foodBasketFood plusz fv-ét
            }
        else
            {
            if(!isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]))
                { // ha nincs ilyen dátumú foodBasketDay, akkor csinál egyet
                $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]=new foodBasketDay($datum,$this);
                }
            $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->create($etelid,$n); // létehozza az adott foodBasketFood -ot a megadott darabszámmal
            }
        return($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]->getDB());  // visszaadja az új darabszámot    
        }

    function pluszheti($etelid,$n,$hetikategorianev)
         {// adott datum objektumhoz (foodBasketDay) (etelid alapján: etelid = [kategoriakod-eeee-hh-nn]) (foodBasketWeekFood) hozzáad $n darabot
         $datum=$this->etlapsorok[$etelid]['datum'];
        $kategorianev=$this->etlapsorok[$etelid]['Kategoria'];
        $Ar=$this->etlapsorok[$etelid]['hetiAr'];
          if(isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$hetikategorianev]))
            { // ha van ilyen dátumú,kategóriájú foodBasketWeekFood
            $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$hetikategorianev]->plusz($n); // hívja a foodBasketWeekFood plusz fv-ét, ami a neki megfelelő foodBasketWeek -nek adja tovább.
            }
        else
            {
            if(!isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]))
                { // ha nincs csinál egy
                $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]=new foodBasketDay($datum,$this);
                }
            if(!isset($this->hetirendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$hetikategorianev]))
                { // ha van ilyen dátumú, kategóriájú foodBasketWeek akkor csinál egyet ( a foodBasketWeekFood-hoz kell, mert az abba is ír)
                $this->hetirendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$hetikategorianev]=new foodBasketWeek($kategorianev,$Ar,$hetikategorianev,$this);
                }
            $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->createWeekFood($etelid,$n,$this->hetirendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$hetikategorianev]); // létehozza az adott foodBasketWeekFood -ot a megadott darabszámmal
            }
        return($this->hetirendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$hetikategorianev]->getDB());   // visszaadja az új darabszámot erre a "heti" ételre   
        }

    function pluszhetiarray($arr)
        {
        $this->addok=false;
        foreach($arr as $etel)
            {
            $this->pluszheti($etel['etelid'],$etel['db'],$etel['hetikategoria']);
            }
        }
        
    function minusz($etelid,$n)
        {
        $datum=$this->etlapsorok[$etelid]['datum'];
        $kategorianev=$this->etlapsorok[$etelid]['Kategoria'];
        if(isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]))
            {
            $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]->minusz($n);
            return($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]->getDB()); 
            }
        else
            {
            return(0);
            }
        }    
    
    function minuszheti($etelid,$n,$hetikategorianev)
         {
         $datum=$this->etlapsorok[$etelid]['datum'];
        $kategorianev=$this->etlapsorok[$etelid]['Kategoria'];
        $Ar=$this->etlapsorok[$etelid]['hetiAr'];
        
          if(isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$hetikategorianev]))
            {
            $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$hetikategorianev]->minusz($n);
            return($this->hetirendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$hetikategorianev]->getDB());  
            }
         else
            {
            return(0);
            }
        }

    function minuszhetiarray($arr)
        {
        $this->addok=false;
        foreach($arr as $etel)
            {
            $this->minuszheti($etel['etelid'],$etel['db'],$etel['hetikategoria']);
            }
        }
  

  

    function getKollega($etelid,$i)
        {
        $datum=$this->etlapsorok[$etelid]['datum'];
        $kategorianev=$this->etlapsorok[$etelid]['Kategoria'];
        return($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]->getKollega($i));
        }
     
    function setKollega($etelid,$i,$id)
        {
        $datum=$this->etlapsorok[$etelid]['datum'];
        $kategorianev=$this->etlapsorok[$etelid]['Kategoria'];
        $this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]->setKollega($i,$id);
        }  
  
    function getKollegaHeti($ev,$het,$kategoria,$i)
        {
        $datum=$this->etlapsorok[$etelid]['datum'];
        $kategorianev=$this->etlapsorok[$etelid]['hetiKategoria'];
        $ev=foodDatum::getEv($datum);
        $het=foodDatum::getHet($datum);
        return($this->hetirendeles[$ev][$het][$kategorianev]->getKollega($i));
        }
     
    function setKollegaHeti($etelid,$i,$id)
        {
        $datum=$this->etlapsorok[$etelid]['datum'];
        $kategorianev=$this->etlapsorok[$etelid]['hetiKategoria'];
        $ev=foodDatum::getEv($datum);
        $het=foodDatum::getHet($datum);
        $this->hetirendeles[$ev][$het][$kategorianev]->setKollega($i,$id);
        }  



        
    function getDB($datum=null,$kategorianev=null)
        {
        if(is_null($datum))
            {
            $this->db=0;
            
           foreach($this->rendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $datumnev => $datum)
                    {
                    $this->db+=$datum->getDB();
                    }
                }
            }
            return($this->db);
            }
            
         if(!is_null($datum) && is_null($kategorianev))
            {
            if(isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]))
                {
                return($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->getDB());
                }
            else
                {
                return(0);
                }
            } 
            
         if(!is_null($datum) && !is_null($kategorianev))
            {
            if(isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]))
                {
                return($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]->getDB());
                }
             else
                {
                return(0);
                }
            } 
        }

    function getAllDB($evneve=null,$hetneve=null)
        {
        if(is_null($evneve))
            {
            $this->alldb=$this->getDB()+$this->gethetirendelesDB();
            return($this->alldb);
            }
 
         if(!is_null($evneve) && !is_null($hetneve))
            {
            $db=0;
            foreach($this->rendeles[$evneve][$hetneve] as $datumnev => $datum)
                {
                $db+=$datum->getDB();
                }
            return($this->gethetirendelesDB($evneve,$hetneve)+$db);
            }
        }

    function getFullDB($evneve=null,$hetneve=null)
        {
        $db=0;
        if(is_null($evneve))
            {
            foreach($this->rendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    foreach($het as $datumnev => $datum)
                        {
                        $db+=$datum->getFullDB();
                        }
                    }
                }
            return($db);
            }
         
        if(!is_null($evneve) && !is_null($hetneve))
            {
            if(isset($this->rendeles[$evneve][$hetneve]))
                {
                foreach($this->rendeles[$evneve][$hetneve] as $datumneve => $datum)
                    {
                    $db+=$datum->getFullDB();
                    }
                return($db);
                }
            else
                {
                return(0);
                }
            }          
         
        }        
    
    function gethetirendelesDB($evneve=null,$hetneve=null,$kategorianev=null)
        {//$evneve,$hetneve,$kategorianev
        if(is_null($evneve))
            {
            $this->hetidb=0;
            
           foreach($this->hetirendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $kategorianev => $kategoria)
                    {
                    $this->hetidb+=$kategoria->getDB();
                    }
                }
            }
            return($this->hetidb);
            }
            
         if(!is_null($evneve) && !is_null($hetneve) && is_null($kategorianev))
            {
            $db=0;
            
            if(isset($this->hetirendeles[$evneve][$hetneve]))
                {
                foreach($this->hetirendeles[$evneve][$hetneve] as $kategorianev => $kategoria)
                    {
                    $db+=$kategoria->getDB();
                    }
                return($db);
                }
            else
                {
                return(0);
                }
            } 
            
         if(!is_null($evneve) && !is_null($hetneve) && !is_null($kategorianev))
            {
            if(isset($this->hetirendeles[$evneve][$hetneve][$kategorianev]))
                {
                return($this->hetirendeles[$evneve][$hetneve][$kategorianev]->getDB());
                }
             else
                {
                return(0);
                }
            }
        }    
    
    
    
    function getSum($datum=null,$kategorianev=null)
        {
        if(is_null($datum))
            {
            $this->sum=0;
           foreach($this->rendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $datum)
                    {
                     $this->sum+=$datum->getSum();
                    }
                }
            }
            return($this->sum);
            }
            
         if(!is_null($datum) && is_null($kategorianev))
            {
            if(isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]))
                {
                return($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->getSum());
                }
            else
                {
                return(0);
                }
            } 
            
         if(!is_null($datum) && !is_null($kategorianev))
            {
            if(isset($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]))
                {
                return($this->rendeles[foodDatum::getEv($datum)][foodDatum::getHet($datum)][$datum]->kategoriak[$kategorianev]->getSum());
                }
             else
                {
                return(0);
                }
            } 
        }    
 
    function getSumKedvezmenyes($ev=null,$het=null,$datum=null,$kategorianev=null)
        {
        if(is_null($ev))
            {
            foodDisCounter::reset();
           foreach($this->rendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $datum)
                    {
                    $datum->addtoDisCounter();
                    }
                }
            }
            return(foodDisCounter::reszosszeg());
            }
          
         if(!is_null($ev) && !is_null($het) && is_null($datum) && is_null($kategoria))
            {
            if(isset($this->rendeles[$ev][$het]))
                {
                foodDisCounter::reset();
                foreach($this->rendeles[$ev][$het] as $datum)
                    {
                    $datum->addtoDisCounter();
                    }
                return(foodDisCounter::reszosszeg());
                }
            else
                {
                return(0);
                }
            }

         if(!is_null($ev) && !is_null($het) && !is_null($datum) && is_null($kategoria))
            {
            if(isset($this->rendeles[$ev][$het][$datum]))
                {
                foodDisCounter::reset();
                $this->rendeles[$ev][$het][$datum]->addtoDisCounter();
                return(foodDisCounter::reszosszeg());
                }
            else
                {
                return(0);
                }
            }
          
         if(!is_null($ev) && !is_null($het) && !is_null($datum) && !is_null($kategoria))
            {
            if(isset($this->rendeles[$ev][$het][$datum]))
                {
                if(isset($this->rendeles[$ev][$het][$datum]->kategoriak[$kategoria]))
                    {
                    foodDisCounter::reset();
                    $this->rendeles[$ev][$het][$datum]->kategoriak[$kategoria]->addtoDisCounter();
                    return(foodDisCounter::reszosszeg());
                    }
                else
                    {
                    return(0);
                    }
                }
            else
                {
                return(0);
                }
            }
        }
 
    function getAllSum($evneve=null, $hetneve=null)
        {
        if(is_null($evneve))
            {
            $this->allsum=$this->getSum()+$this->gethetirendelesSum();
            return($this->allsum);
            }
 
         if(!is_null($evneve) && !is_null($hetneve))
            {
            $sum=0;
            foreach($this->rendeles[$evneve][$hetneve] as $datumnev => $datum)
                {
                $sum+=$datum->getSum();
                }
            return($this->gethetirendelesSum($evneve,$hetneve)+$sum);
            }
        }
 
    function getAllSumKedvezmenyes($ev=null,$het=null)
        {
        if(is_null($ev))
            {
            return($this->getSumKedvezmenyes()+$this->gethetirendelesSumKedvezmenyes());
            }
        if(!is_null($ev) && !is_null($het))
            {
            return($this->getSumKedvezmenyes($ev,$het) + $this->gethetirendelesSumKedvezmenyes($ev,$het));
            }
        } 
 
    function gethetirendelesSumKedvezmenyes($evneve=null,$hetneve=null,$kategorianev=null)
        {
        if(is_null($evneve))
            {
            foodDisCounter::reset();
            
           foreach($this->hetirendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $kategorianev => $kategoria)
                    {
                    $kategoria->addtoDisCounter();
                    }
                }
            }
            return(foodDisCounter::reszosszeg());
            }
            
         if(!is_null($evneve) && !is_null($hetneve) && is_null($kategorianev))
            {
            foodDisCounter::reset();
            
            if(isset($this->hetirendeles[$evneve][$hetneve]))
                {
                foreach($this->hetirendeles[$evneve][$hetneve] as $kategorianev => $kategoria)
                    {
                    $kategoria->addtoDisCounter();
                    }
                return(foodDisCounter::reszosszeg());
                }
            else
                {
                return(0);
                }
            } 
            
         if(!is_null($evneve) && !is_null($hetneve) && !is_null($kategorianev))
            {
            foodDisCounter::reset();
            if(isset($this->hetirendeles[$evneve][$hetneve][$kategorianev]))
                {
                $this->hetirendeles[$evneve][$hetneve][$kategorianev]->addtoDisCounter();
                return(foodDisCounter::reszosszeg());
                }
             else
                {
                return(0);
                }
            }
        } 
 
    function gethetirendelesSum($evneve=null,$hetneve=null,$kategorianev=null)
        {
        if(is_null($evneve))
            {
            $this->hetisum=0;
            
           foreach($this->hetirendeles as $evneve => $ev)
            {
            foreach($ev as $hetneve => $het)
                {
                foreach($het as $kategorianev => $kategoria)
                    {
                    $this->hetisum+=$kategoria->getSum();
                    }
                }
            }
            return($this->hetisum);
            }
            
         if(!is_null($evneve) && !is_null($hetneve) && is_null($kategorianev))
            {
            $sum=0;
            
            if(isset($this->hetirendeles[$evneve][$hetneve]))
                {
                foreach($this->hetirendeles[$evneve][$hetneve] as $kategorianev => $kategoria)
                    {
                    $sum+=$kategoria->getSum();
                    }
                return($sum);
                }
            else
                {
                return(0);
                }
            } 
            
         if(!is_null($evneve) && !is_null($hetneve) && !is_null($kategorianev))
            {
            if(isset($this->hetirendeles[$evneve][$hetneve][$kategorianev]))
                {
                return($this->hetirendeles[$evneve][$hetneve][$kategorianev]->getSum());
                }
             else
                {
                return(0);
                }
            }
        }
 
 
    function initFromPost($muvelet)
        {
        foodSession::clearSESSION($muvelet);
        $this->etlapsorok=foodEtlap::getEtlap();
        if(!empty($_POST["hetirendeles"]) || !empty($_POST["rendeles"]))
            {
            $hetirendeles=$_POST["hetirendeles"];
            $hetietelek=array();
            $darab=array();
            if(!empty($_POST["hetirendeles"]))
                {
                foreach($hetirendeles as $hetikategoria => $db)
                    {
                    $etel=$db["db"];
                    while( is_array($etel) )
                        {
                        list($etelid,$etel)=each($etel);
                        $hetietelek[$hetikategoria][]=array('etelid' => $etelid , 'hetikategoria' => $hetikategoria );
                        }
                     $darab[$hetikategoria]=$etel;
                    }
                    
                foreach($hetietelek as $hetikategoria => &$etelek)
                    {
                    foreach($etelek as &$egyetel)
                        {
                        $egyetel['db']=$darab[$hetikategoria];
                        }
                    unset($etelek);
                    unset($egyetel);
                    }
                    
                foreach($hetietelek as $eteltomb)
                    {
                    list($key,$elso)=each($eteltomb);
                    if(is_numeric($elso['db']) && $elso['db']>0)
                        {
                        $this->pluszhetiarray($eteltomb);
                        }
                    }
                }
            if(!empty($_POST["rendeles"]))
                {
                foreach($_POST["rendeles"] as $etelid => $db)
                    {
                    if(is_numeric($db['db']) && $db['db']>0)
                        {
                        $this->plusz($etelid,floor($db['db']));
                        }
                    }
                }
            }
        }


 
    function initFromSession()
        {
        $hetikategoria="";
        $heti=array();
        if(isset($_SESSION["kosar"][$this->nev]))
            {
            $this->etlapsorok=foodEtlap::getEtlap();
            $kosar=array();
            $torolve=foodModule::ifmodule("kosarszuro_module")->delete($this->nev);
            if($torolve!==false)
                {
                $this->messages["torolve"]=$torolve;
                }
            $kosar["etel"]=$_SESSION["kosar"][$this->nev];
            $this->lemma_initfromarray($kosar);
                
            $this->darabolas();
            
            if(isset($_SESSION["kosar"]["kollegak"][$this->nev]))
                {
                $this->lemma_initkollegak($_SESSION["kosar"]["kollegak"][$this->nev]);
                }
                
            if($this->nev=="rendeles" || $this->nev=="lemondas")
                {
                foodSession::clearSESSION($this->nev);
                $this->saveToSESSION();
                }
            }
        }
    
         
    function initFromDBASE_Temp($rendelid)
        {
        $this->etlapsorok=foodEtlap::getEtlap();
        $this->rendelid["rendelid"]=$rendelid;
        $heti=array();
        if($rendelid=="")
            {
            return(false);
            }
  
        $this->nev="Temp_".$rendelid;
        $kosar=array();
        $kollegak=array();
        $conn=foodDB::Connect();
        
        $qy="select ev,het,db,type,kategoria,datum,Ar,Kedvezmeny,etel_id,hetiKategoria,Kedvezmenytipus from cardteszt_rendeles_temp where rendelid=?";
        $st=$conn->prepare($qy);
        
        $qyk="select etelid,kollegaid,sorszam,tipus from rendelesek_kinek_temp where rendelid=?";
        $stk=$conn->prepare($qyk);
        
        if(!$st || !$stk)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        $st->bind_param("s",$rendelid);
        $st->exec();
        
        $stk->bind_param("s",$rendelid);
        $stk->exec();
        
        while($sor=$st->fetch_assoc())
            {
            if($sor["hetiKategoria"]=="")
                {
                $kosar["etel"][$sor["etel_id"]][0]=$sor["db"];
                $kosar["kedvezmeny"][$sor["etel_id"]][0]=array("tipus" =>$sor["Kedvezmenytipus"],"ertek" => $sor["Kedvezmeny"]);
                }
            else
                {
                $kosar["etel"][$sor["etel_id"]][1]=$sor["db"];
                $kosar["kedvezmeny"][$sor["etel_id"]][1]=array("tipus" =>$sor["Kedvezmenytipus"],"ertek" => $sor["Kedvezmeny"]);
                }
            }
            
        while($sork=$stk->fetch_assoc())
            {
            $kollegak[$sor["etel_id"]][$sor["tipus"]][$sor["sorszam"]]=$sor["kollegaid"];
            }   
            
        $this->lemma_initfromarray($kosar);
                
        $this->darabolas();
        
        if(count($kollegak)>0)
            {
            $this->lemma_initkollegak($kollegak);
            }
        }
 
    function initFromDBASE_Korabbi($type,$loginNev,$rendelid)
        {
        foodDisCounter::alap(0);
        $this->etlapsorok=foodEtlap::getEtlap();
        //$rendelid=$this->rendelid["rendelid"];
        $heti=array();
        
        $conn=foodDB::Connect();
        
        if($type==1)
            {
            $this->korabbi="rendeles";
            $tipus=1;
            }
        else
            {
            $this->korabbi="lemondas";
            $tipus=0;
            }
            
        $this->nev=$this->korabbi."_".$loginNev;
        $kosar=array();  
        
        $qy="select rendelid,ev,het,db,type,kategoria,datum,Ar,Kedvezmeny,etel_id,hetiKategoria, ido, Kedvezmenytipus from cardteszt_rendeles_new where loginNev=? and datum>=? and type=? and rendelid=? order by ido";
        $st=$conn->prepare($qy);

        if(!$st)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        $st->bind_param("ssis",$loginNev,foodEtlap::getKezdodatum(),$tipus,$rendelid);
        $st->exec();

        while($sor=$st->fetch_assoc())
            {
            if($sor["ido"]!="" && $this->datum=="")
                {
                $this->datum=substr($sor["ido"],0,10);
$this->ido=$sor["ido"];
                }
             
            if($sor["hetiKategoria"]=="")
                {
                $kosar["etel"][$sor["etel_id"]][0]+=$sor["db"];
                $kosar["kedvezmeny"][$sor["etel_id"]][0]=array("tipus" =>$sor["Kedvezmenytipus"],"ertek" => $sor["Kedvezmeny"]);;
                }
            else
                {
                $kosar["etel"][$sor["etel_id"]][1]+=$sor["db"];
                $kosar["kedvezmeny"][$sor["etel_id"]][1]=array("tipus" =>$sor["Kedvezmenytipus"],"ertek" => $sor["Kedvezmeny"]);;
                }
            }
        
        $this->lemma_initfromarray($kosar);
        }

    function initFromDBASE_Korabbi_Heti($type,$loginNev,$ev,$het,$kedvezmenytipus,$kedvezmeny)
        {
        foodDisCounter::alap(0);
        $this->etlapsorok=foodEtlap::getEtlap();
        //$rendelid=$this->rendelid["rendelid"];
        $heti=array();
        
        $conn=foodDB::Connect();
        
        if($type==1)
            {
            $this->korabbi="rendeles";
            $tipus=1;
            }
        else
            {
            $this->korabbi="lemondas";
            $tipus=0;
            }
            
        $this->nev=$this->korabbi."_".$loginNev;
        $kosar=array();  
        
        $qy="select rendelid,ev,het,db,type,kategoria,datum,Ar,Kedvezmeny,etel_id,hetiKategoria, ido, Kedvezmenytipus from cardteszt_rendeles_new where loginNev=? and datum>=? and type=? and ev=? and het=? and Kedvezmenytipus=? and Kedvezmeny=? order by ido";
        $st=$conn->prepare($qy);

        if(!$st)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        $st->bind_param("ssisiii",$loginNev,foodEtlap::getKezdodatum(),$tipus,$ev,$het,$kedvezmenytipus,$kedvezmeny);
        $st->exec();

        while($sor=$st->fetch_assoc())
            {
            if($sor["ido"]!="" && $this->datum=="")
                {
                $this->datum=substr($sor["ido"],0,10);
                }
             
            if($sor["hetiKategoria"]=="")
                {
                $kosar["etel"][$sor["etel_id"]][0]+=$sor["db"];
                $kosar["kedvezmeny"][$sor["etel_id"]][0]=array("tipus" =>$sor["Kedvezmenytipus"],"ertek" => $sor["Kedvezmeny"]);;
                }
            else
                {
                $kosar["etel"][$sor["etel_id"]][1]+=$sor["db"];
                $kosar["kedvezmeny"][$sor["etel_id"]][1]=array("tipus" =>$sor["Kedvezmenytipus"],"ertek" => $sor["Kedvezmeny"]);;
                }
            }
                    //print_r($kosar);
        $this->lemma_initfromarray($kosar);
        }    
      
      
    function initFromDBASE_Korabbi_Heti_Sum($loginNev,$ev,$het,$nev)
        {
        foodDisCounter::alap(0);
        $this->etlapsorok=foodEtlap::getEtlap();
        //$rendelid=$this->rendelid["rendelid"];
        $heti=array();
        
        $conn=foodDB::Connect();
            
        $this->nev=$nev;
        $kosar=array();  
        
        $qy="select rendelid,ev,het,db,type,kategoria,datum,Ar,Kedvezmeny,etel_id,hetiKategoria, ido, Kedvezmenytipus from cardteszt_rendeles_new where loginNev=? and datum>=?  and ev=? and het=?  order by ido";
        $st=$conn->prepare($qy);

        if(!$st)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        $st->bind_param("sssi",$loginNev,foodEtlap::getKezdodatum(),$ev,$het);
        $st->exec();

        while($sor=$st->fetch_assoc())
            {
            $type=$sor["type"];
            if($sor["ido"]!="" && $this->datum=="")
                {
                $this->datum=substr($sor["ido"],0,10);
                }
             
            if($sor["hetiKategoria"]=="")
                {
                if($type==1)
                    {
                    $kosar["etel"][$sor["etel_id"]][0]+=$sor["db"];
                    }
                else
                    {
                    $kosar["etel"][$sor["etel_id"]][0]-=$sor["db"];
                    }
                }
            else
                {
                if($type==1)
                    {
                    $kosar["etel"][$sor["etel_id"]][1]+=$sor["db"];
                    }
                else
                    {
                    $kosar["etel"][$sor["etel_id"]][1]-=$sor["db"];
                    }
                }
            }
                    //print_r($kosar);
        $this->lemma_initfromarray($kosar);
        }       
      
    function initFromDBASE_Korabbi_Heti_Sum2($loginNev,$ev,$het,$kedvezmenytipus,$kedvezmeny)
        {
        foodDisCounter::alap(0);
        $this->etlapsorok=foodEtlap::getEtlap();
        //$rendelid=$this->rendelid["rendelid"];
        $heti=array();
        
        $conn=foodDB::Connect();
            
        //$this->nev=$nev;
        $kosar=array();  
        
        $qy="select rendelid,ev,het,db,type,kategoria,datum,Ar,Kedvezmeny,etel_id,hetiKategoria, ido, Kedvezmenytipus from cardteszt_rendeles_new where loginNev=? and datum>=?  and ev=? and het=? and Kedvezmenytipus=? and Kedvezmeny=? order by ido";
        $st=$conn->prepare($qy);

        if(!$st)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        $st->bind_param("sssiii",$loginNev,foodEtlap::getKezdodatum(),$ev,$het,$kedvezmenytipus,$kedvezmeny);
        $st->exec();

        while($sor=$st->fetch_assoc())
            {
            $type=$sor["type"];
            if($sor["ido"]!="" && $this->datum=="")
                {
                $this->datum=substr($sor["ido"],0,10);
                }
             
            if($sor["hetiKategoria"]=="")
                {
                if($type==1)
                    {
                    $kosar["etel"][$sor["etel_id"]][0]+=$sor["db"];
                    }
                else
                    {
                    $kosar["etel"][$sor["etel_id"]][0]-=$sor["db"];
                    }
                }
            else
                {
                if($type==1)
                    {
                    $kosar["etel"][$sor["etel_id"]][1]+=$sor["db"];
                    }
                else
                    {
                    $kosar["etel"][$sor["etel_id"]][1]-=$sor["db"];
                    }
                }
            }
                    //print_r($kosar);
        $this->lemma_initfromarray($kosar);
        }  
 
    function lemma_initfromarray($kosar)
        {
        $hetikategoria="";
        $heti=array();
        foreach($kosar["etel"] as $etelid => $etel)
            {// etelid: kategoriakod-eeee-hh-nn, etel: pl. 0 => 1 ( tipus => db , "sima" napi étel) vagy 1 => 2  ( tipus => db , "heti" étel)
            foreach($etel as $tipus => $db)
                {
                if($db>0)
                    {
                    if($tipus==0)
                        {
                        if(isset($kosar["kedvezmeny"][$etelid][0]))
                            {
                            $this->lastkedvezmeny=$kosar["kedvezmeny"][$etelid][0];
                            }
                        $this->plusz($etelid,$db);// ha nem heti, akkor "sima" plusz
                        $this->lastkedvezmeny=null;
                        }
                    else
                        {
                        if(isset($kosar["kedvezmeny"][$etelid][1]))
                            {
                            $lastkedvezmeny=$kosar["kedvezmeny"][$etelid][1];
                            }
                        else
                            {
                            $lastkedvezmeny=null;
                            }
                        $heti[$this->etlapsorok[$etelid]["heteve"]][$this->etlapsorok[$etelid]["Het"]][$this->etlapsorok[$etelid]["hetiKategoria"]][]=array("etelid" => $etelid, "db" => $db, "hetikategoria" => $this->etlapsorok[$etelid]["hetiKategoria"], "kedvezmeny"=> $lastkedvezmeny );
                        }
                    }
                }
            }
              
        if(!empty($heti))
            {
            foreach($heti as $heteve => $ev)
                {
                foreach($ev as $hetneve => $het )
                    {
                    foreach($het as $hetikategoria => $eteltomb)
                        {
                        $this->lastkedvezmeny=$eteltomb["kedvezmeny"];
                        $this->pluszhetiarray($eteltomb);
                        $this->lastkedvezmeny=null;
                        }
                    }
                }
            }
        }
    
    function lemma_initkollegak($kollegak)
        {
        foreach($kollegak as $etelid => $etel)
            {
            foreach($etel as $tipus => $kollega)
                {
                foreach($kollega as $sorszam => $kollegaid)
                    {
                    if($tipus==0)
                        {
                        $this->setKollega($etelid,$sorszam,$kollegaid);
                        }
                    if($tipus==1)
                        {
                        $this->setKollegaHeti($etelid,$sorszam,$kollegaid);
                        }
                    }
                }
            }
        }
    
    function saveToSESSION($ev_neve=null,$het_neve=null)
        {
        $this->etlapsorok=foodEtlap::getEtlap();
        if(is_null($ev_neve))
            {
            foreach($this->rendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    $this->saveToSESSION($evneve,$hetneve);
                    }
                }
            $_SESSION["kosar"][$this->nev."_vasarlasOsszegeFT"]=$this->getAllSum();
            }
            
         if(!is_null($ev_neve) && !is_null($het_neve))
            {    
            foreach($this->rendeles[$ev_neve][$het_neve] as $datumneve => $datum)
                {
                $datum->saveToSESSION();
                }
            }
            
        }
   
    function saveToDBASE($type,$evneve=null,$hetneve=null)
        {
        if(is_null($evneve))
            {
            foreach($this->rendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    $this->saveToDBASE($type,$evneve,$hetneve);
                    }
                }
            }
         else
            {
            $this->saveToDBASEHet($type,$evneve,$hetneve);
            foreach($this->rendeles[$evneve][$hetneve] as $datumneve => $datum)
                {
                $datum->saveToDBASE($type);
                }
            }
            
        }
    
    function saveToDBASEHet($type,$evneve,$hetneve)
        {
        if($this->nev!="rendeles")
            {
            return;
            }
        if(foodModule::ifmodule("regisztracio_akcio_module")->akcios($evneve,$hetneve))
            {
            if($nexthet=foodModule::ifmodule("regisztracio_akcio_module")->get_next($evneve,$hetneve))
                {
                $ujev=$nexthet["ev"]; $ujhet=$nexthet["het"];
                foodModule::getmodule("regisztracio_akcio_module")->storeKedvezmeny(foodUser::getuserData("idlogin"),$ujev,$ujhet);
                }
            }
        
        $conn=foodDB::Connect();
        $qy="insert into rendeles_heti(rendelid, loginNev,osszeg,ev,het) values(?,?,?,?,?)";
        $st=$conn->prepare($qy);
        if(!$st)
            {
            exit(ADATBAZISSZOVEG_FRONTEND);
            }
        $st->bind_param("ssdsi",$this->getrendelid(),foodUser::getUserData("loginNev"),$this->getAllSumKedvezmenyes($evneve,$hetneve),$evneve,$hetneve);
        $st->exec();
        }
    
    function deleteFromDbase_Temp($rendelid)
        {
        $conn=foodDB::Connect();
        $qy="delete from cardteszt_rendeles_temp where rendelid=?";
        $st=$conn->prepare($qy);
        if(!$st)
            {
            exit(ADATBAZISSZOVEG_FRONTEND);
            }
        else
            {
            $st->bind_param("i",$rendelid);
            $st->exec();
            }
        }
    
    function saveFile($evneve=null,$hetneve=null)
        {
        if(is_null($evneve))
            {
            foreach($this->rendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    $this->saveFile($evneve,$hetneve);
                    }
                }
            }
        else
            {
            $hete=(int)$hetneve;
            if($this->nev=="rendeles")
                {
                $tipusnev="rendeles";
                $tipusszoveg="rendelés";
                $tipusjel='r';
                }
                
             if($this->nev=="lemondas")
                {
                $tipusnev="lemondás";
                $tipusjel='l';
                } 
                
            $txtfilenev=TXTDIR.$this->rendelid["datepart"].'_'.$hete.$tipusjel.'_'.$this->rendelid["userpart"].".txt";
$txtfilenev2=$this->rendelid["datepart"].'_'.$hete.$tipusjel.'_'.$this->rendelid["userpart"].".txt";
            $fileba=$this->mail[$evneve][$hetneve]["fileba"];
            if(foodUser::getuserData("temp")!=1 && foodUser::getuserData("ujreg")!=1 && foodUser::getuserData("loginNev")!="172551")
                {
            foodModule::ifmodule("letoltes_module")->save($this->rendelid["datepart"].'_'.$this->rendelid["userpart"],$evneve,$hetneve,1,$txtfilenev2,$fileba);
                }
            $fp=fopen($txtfilenev,"w");
            if($fp)
                {
                $ok=fwrite($fp,$fileba);
                return($ok);
                }
            else
                {
                return(false);
                }
            }

        }
    
    function sendAdminMail($evneve=null,$hetneve=null,$email=null)
        {
        $ok=true; $emailcim=false;
        $masemail=foodString::regex($evneve,foodConstants::$MAILPATTERN);
        if($masemail=="OK")
            {
            $emailcim=$evneve;
            }
        if(is_null($evneve) || $masemail=="OK")
            {
            foreach($this->rendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    if($masemail=="OK")
                        {
                        $m=$this->sendAdminMail($evneve,$hetneve,$emailcim);
                        }
                    else
                        {
                        $m=$this->sendAdminMail($evneve,$hetneve);
                        }
                    if(!$m)
                        {
                        $ok=false;
                        }
                    }
                }
            return($ok);
            }
            
         else
            {
            if(!is_null($email))
                {
                $masemail="OK";
                }
            $hete=(int)$hetneve;
            
            if($this->nev=="rendeles")
                {
                $tipusnev="rendeles";
                $tipusszoveg=foodString::out("rendelés");
                $tipussubject=foodString::out("Ételrendelés");
                if(foodUser::getuserData("loginNev")=="172551")
                    {
                    $tipussubject="TESZT - ".$tipussubject;
                    }
                $tipusjel='r';
                }
                
             if($this->nev=="lemondas")
                {
                $tipusnev="lemondas";
                $tipusszoveg=foodString::out("lemondás");
                $tipussubject=foodString::out("Lemondás");
                if(foodUser::getuserData("loginNev")=="172551")
                    {
                    $tipussubject="TESZT - ".$tipussubject;
                    }
                $tipusjel='l';
                } 
            
            $txtfilenev=$this->rendelid["datepart"].'_'.$hete.$tipusjel.'_'.$this->rendelid["userpart"].".txt";
            
            $aktualiscim=foodUser::getaktualiscim();
            $this->data=$aktualiscim;
            $this->data["Kedvezmeny"]=$this->Kedvezmeny;
            $this->data["Email"]=foodUser::getuserData("Email");
            $this->data['date']=date("Y-m-d H:i:s");
            $this->data['txtlink']=FOODSITE.TXTDIR.$txtfilenev;
            
            $this->data["rendelesek"]=$this->mail[$evneve][$hetneve]["szoveg"];
            
            $this->data["osszesdb"]=$this->getFullDB($evneve,$hetneve);
            
            $this->data["osszesar"]=$this->getAllSum($evneve,$hetneve);
            
            $this->data["kedvezmenyesar"]=$this->getAllSumKedvezmenyes($evneve,$hetneve);
            
            require_once("class_foodMailer.php");
            
            //require_once(TEMPLATEDIR."template_admin".$tipusnev."mail.php");
            
            //$ma="template_admin".$tipusnev."mail";
            
            //$mail=new $ma($this);
            
            $mail=foodFactory::simpleBox("mail/admin".$tipusnev."mail",$this);
            
            $admails=adminmails::getAdminMails();
            $admail=$admails[1];
            
            if($masemail=="OK")
                {
                $admail=$email;
                }
            
            $m=new foodMailer();
            
            $m->mailer->AddAddress($admail,MAILNEVHOSSZU);
         
            $m->mailer->From=$admail;
            $m->mailer->FromName=MAILNEVROVID;
            $m->mailer->Sender=$admail; 
            $m->mailer->AddReplyTo($admail, foodString::out("Válaszcím")); 
            $ezahet=$hetneve.'. hét';
            $hete=foodString::regex($ezahet,foodConstants::$HETPATTERN);
            $m->mailer->Subject = $tipussubject." (".$hete.")";
            foodUser::setUserData();
            foodUser::setAddresses();
            
            $m->mailer->AddAttachment(TXTDIR.$txtfilenev, $txtfilenev);
            $m->mailer->IsHTML(false);
            ob_start();
            $mail->Run();
            $m->mailer->Body = ob_get_clean();
if((foodUser::getuserData("temp")==1 || foodUser::getuserData("ujreg")==1) && foodUser::getuserData("loginNev")!="172551")
                {
                $m->mailer->Subject.=foodString::out(" - Azonosító nélkül");
                foodModule::ifmodule("letoltes_module")->save($this->rendelid["datepart"].'_'.$this->rendelid["userpart"],$evneve,$hetneve,0,$txtfilenev,$m->mailer->Body);
                }
            if(!$m->mailer->Send())
                {
                return(false);
                }
            else
                {
                return(true);
                }
            }   
         
        }
    
    
    function sendUserMail($evneve=null,$hetneve=null)
        {
        $ok=true;
        if(is_null($evneve))
            {
            foreach($this->rendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    $m=$this->sendUserMail($evneve,$hetneve);
                    if(!$m)
                        {
                        $ok=false;
                        }
                    }
                }
            return($ok);
            }
            
         else
            {  
            if($this->nev=="rendeles")
                {
                $tipusnev="rendeles";
                $tipusszoveg=foodString::out("rendelés");
                $tipussubject=foodString::out("Ételrendelés");
                if(foodUser::getuserData("loginNev")=="172551")
                    {
                    $tipussubject="TESZT - ".$tipussubject;
                    }
                $tipusjel='r';
                }
                
             if($this->nev=="lemondas")
                {
                $tipusnev="lemondas";
                $tipusszoveg=foodString::out("lemondás");
                $tipussubject=foodString::out("Lemondás");
                if(foodUser::getuserData("loginNev")=="172551")
                    {
                    $tipussubject="TESZT - ".$tipussubject;
                    }
                $tipusjel='l';
                } 

            $aktualiscim=foodUser::getaktualiscim();
            $this->data=$aktualiscim;
            $this->data["Kedvezmeny"]=$this->Kedvezmeny;
            $this->data["Email"]=foodUser::getuserData("Email");
            $this->data['date']=date("Y-m-d H:i:s");
            
            $this->data["rendelesek"]=$this->mail[$evneve][$hetneve]["szoveg"];
            
            $this->data["osszesdb"]=$this->getFullDB($evneve,$hetneve);
            
            $this->data["osszesar"]=$this->getAllSum($evneve,$hetneve);
            
            $this->data["kedvezmenyesar"]=$this->getAllSumKedvezmenyes($evneve,$hetneve);
            
            require_once("class_foodMailer.php");
            
            //require_once(TEMPLATEDIR."template_user".$tipusnev."mail.php");
            
            //$ma="template_user".$tipusnev."mail";
            
            //$mail=new $ma($this);
            
            $mail=foodFactory::simpleBox("mail/user".$tipusnev."mail",$this);
            
            $admails=adminmails::getAdminMails();
            $admail=$admails[1];
            
            $m=new foodMailer();
            
            $m->mailer->AddAddress($this->data["Email"],$this->data["Nev"]);
         
            $m->mailer->From=$admail;
            $m->mailer->FromName=MAILNEVROVID;
            $m->mailer->Sender=$admail; 
            $m->mailer->AddReplyTo($admail, foodString::out("Válaszcím")); 
            $ezahet=$hetneve.'. hét';
            $hete=foodString::regex($ezahet,foodConstants::$HETPATTERN);
            $m->mailer->Subject = $tipussubject." (".$hete.")";
            $m->mailer->IsHTML(false);
            ob_start();
            $mail->Run();
            $m->mailer->Body = ob_get_clean();
            
            if(!$m->mailer->Send())
                {
                return(false);
                }
            else
                {
                return(true);
                } 
            }   
          
        }
    
    
    function genMail($type,$evneve=null,$hetneve=null)
        {
        if(is_null($evneve))
            {
            foreach($this->rendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    $this->genMail($type,$evneve,$hetneve);
                    }
                }
            }
         else
            {   
            $this->mail[$evneve][$hetneve]["szoveg"]=$this->display_heti($type,"BUFFERRETURN",$evneve,$hetneve).$this->display($type,"BUFFERRETURN",$evneve,$hetneve);
            
            $this->mail[$evneve][$hetneve]["fileba"]=$this->display_heti("TXT","BUFFERRETURN",$evneve,$hetneve).$this->display("TXT","BUFFERRETURN",$evneve,$hetneve);
            }
        }
     
    function lemma_uksort_heti($kategoria1,$kategoria2)
        {
        $etlap=foodEtlap::getHetiEtlap();
        if($etlap[$kategoria1]["ssz"]<$etlap[$kategoria2]["ssz"])
            {
            return(-1);
            }
        else
            {
            if($etlap[$kategoria1]["ssz"]>$etlap[$kategoria2]["ssz"])
                {
                return(1);
                }
            }
        return(0);
        }
     
     function rendez_heti($evneve,$hetneve)
        {
        uksort($this->hetirendeles[$evneve][$hetneve],array($this,"lemma_uksort_heti"));
        }
     
    function display_heti($style,$dest,$evneve=null,$hetneve=null)
        {
        $buffer="";
        
        if(is_null($evneve))
            {
            foreach($this->hetirendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    $this->rendez_heti($evneve,$hetneve);
                    foreach($this->hetirendeles[$evneve][$hetneve] as $kategoria)
                        {
                        $buffer.=$kategoria->display($style,$dest,array("evneve" => $evneve, "hetneve" => $hetneve));
                        }
                     }
                }
            }
        
        else
            {
            if(isset($this->hetirendeles[$evneve][$hetneve]))
                {
                $this->rendez_heti($evneve,$hetneve);
                foreach($this->hetirendeles[$evneve][$hetneve] as $kategoria)
                    {
                    $buffer.=$kategoria->display($style,$dest,array("evneve" => $evneve, "hetneve" => $hetneve));
                    }
                }
            }
        return($buffer);
        }
     
    function display($style,$dest,$evneve=null,$hetneve=null)
        {
        $retvalue="";
        $buffer="";
        
        if(is_null($evneve))
            {
            foreach($this->rendeles as $evneve => $ev)
                {
                foreach($ev as $hetneve => $het)
                    {
                    foreach($het as $datumnev => $datum)
                        {
                        $buffer.=$datum->display($style,$dest,array("evneve" => $evneve, "hetneve" => $hetneve));
                        }
                    }
                }    
              }
               
        else
            {
            if(isset($this->rendeles[$evneve][$hetneve]))
                {
                foreach($this->rendeles[$evneve][$hetneve] as $datumnev => $datum)
                    {
                    $buffer.=$datum->display($style,$dest,array("evneve" => $evneve, "hetneve" => $hetneve));
                    }
                }
            }
        return($buffer);
        }
    }

class foodBasketDay 
    {// adott dátumhoz tartozó ételek tárolására (foodBasketFood és  foodBasketWeekFood típusú objektumok a $kategoriak tömbben ), és műveletek a tömbön és elemein
    public $datum;
    public $kosar;
    public $key;
    public $kategoriak;
    public $sum;
    public $db=0;
    
    function __construct($datum,$kosar)
        {// datum egy string: eeee-hh-nn, $kosar a foodBasket -hez referencia 
        $this->datum=$datum;
        $this->kosar=$kosar;
        $this->key=$datum;
        }
     
     function saveToDBASE($type)
        {
        foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            $kategoria->saveToDBASE($type); // továbbadja a mentést a foodBasketFood -nak
            }
        }
     
     function saveToSESSION()
        {
        foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            $kategoria->saveToSESSION(); // továbbadja a mentést a foodBasketFood -nak
            }
        }
     
     function create($etelid,$n)
        { // ehhez a dátumhoz a kategoriak tömmbe létrehoz a kategóriának egy foodBasketFood objektumot
        $kategorianev=$this->kosar->etlapsorok[$etelid]['Kategoria'];
        if(!isset($this->kategoriak[$kategorianev]))
            {
            $this->kategoriak[$kategorianev]=new foodBasketFood($etelid,$n,$this,$this->kosar);
            }
        }
     
     function createWeekFood($etelid,$n,$week)
        {// ehhez a dátumhoz a kategoriak tömmbe létrehoz a kategóriának egy foodBasketWeekFood objektumot, annak pedig kell a $week (foodBasketWeek) objektum, amihez tartozik
        $kategorianev=$this->kosar->etlapsorok[$etelid]['Kategoria'];
        $hetikategorianev=$this->kosar->etlapsorok[$etelid]['hetiKategoria'];
        if(!isset($this->kategoriak[$hetikategorianev]))
            {
            $this->kategoriak[$hetikategorianev]=new foodBasketWeekFood($etelid,$n,$this,$this->kosar,$hetikategorianev,$week);
            }
        }
     
     function lemma_uksort($kategoria1,$kategoria2)
        {
        $etlap=foodEtlap::getEtlap();
        $kod1=foodFunctions::getEtelId($kategoria1,$this->datum);
        $kod2=foodFunctions::getEtelId($kategoria2,$this->datum);
        if($etlap[$kod1]["ssz"]<$etlap[$kod2]["ssz"])
            {
            return(-1);
            }
        else
            {
            if($etlap[$kod1]["ssz"]>$etlap[$kod2]["ssz"])
                {
                return(1);
                }
            }
        return(0);
        }
     
     function rendez()
        {
        uksort($this->kategoriak,array($this,"lemma_uksort"));
        }
     
     function display($style,$dest,$attr)
        {// $this: referencia a kosár objektunhoz, style: RENDELES, LEMONDAS,USERMAIL, TXT, stb. , $dest: FLUSH vagy BUFFERRETURN, attr: átadandó attribútumok tömbje
        $this->rendez();
        $buffer="";
        $elso=true;
        foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            if(!$kategoria->egeszhetre)
                { 
                $attr["elso"]=$elso;
                $buffer.=$kategoria->display($style,$dest,$attr); // továbbadja a foodBasketFood-nak
                $elso=false;
                }
            }
        return($buffer);
        }
     
     function darabolas()
        {
        foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            if(!$kategoria->egeszhetre)
                { // csak a nem egészhetit darabolja
                $kategoria->darabolas(); // továbbadja a foodBasketFood -nak
                }
            }
        }
     
     function getSum()
        {
        $this->sum=0;
        foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            if(!$kategoria->egeszhetre)
                { // // csak a nem egészhetit számolja
                $this->sum+=$kategoria->getSum(); // továbbadja a foodBasketFood -nak
                }
            }
        return($this->sum);
        }
      
     function getSumKedvezmenyes()
        {
        foodDisCounter::reset();
        foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            if(!$kategoria->egeszhetre)
                { // // csak a nem egészhetit számolja
                $kategoria->addtoDisCounter();
                //foodDisCounter::add($kategoria); // továbbadja a foodBasketFood -nak
                }
            }
        return(foodDisCounter::reszosszeg());
        }
        
     function addtoDisCounter()
        {
        foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            if(!$kategoria->egeszhetre)
                { // // csak a nem egészhetit számolja
                $kategoria->addtoDisCounter();
                //foodDisCounter::add($kategoria); // továbbadja a foodBasketFood -nak
                }
            }
        }
      
     function getDB()
        {
        $this->db=0;
         foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            if(!$kategoria->egeszhetre)
                { // csak a nem egészhetit számolja
                $this->db+=$kategoria->getDB(); // továbbadja a foodBasketFood -nak
                }
            }
        return($this->db);
        }
     
    function getFullDB()
        {
        $db=0;
         foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            $db+=$kategoria->getDB(); // beleszámolja az egészhetit is!
            }
        return($db);
        }
     
     function emptyDay()
        {
        $this->datum="";
        $this->key="";
         foreach($this->kategoriak as $kategorianev => $kategoria)
            {
            unset($this->kategoriak[$kategorianev]);
            }
        $this->kategoriak=array();
        $this->sum=0;
        $this->db=0;
        }
    
    }
 
class foodBasketFood
    {
    public $etelid;
    public $db=0;
    public $datum;
    public $kosar;
    public $kategorianev;
    public $key;
    public $kedvezmeny=null;
    
    public $sum;
    public $kollegak=array();
    
    
    function __construct($etelid,$db,$datum,$kosar)
        { // etelid: kategiriakod-eeee-hh-nn, db: darab, $datum: referencia a foodBasketDay objektumhoz, kosar: ref. a foodBasket -hez
        $this->etelid=$etelid;
        $this->db=$db;
        $this->datum=$datum;
        $this->kosar=$kosar;
        
        $this->kategorianev=$this->getAttr("Kategoria");
        $this->key=$this->kategorianev;
        if(!is_null($this->kosar->lastkedvezmeny))
            {
            $this->kedvezmeny=$this->kosar->lastkedvezmeny;
            }
        }
     
     function getAttr($attr)
        {// a foodEtlap által kiszedett tömmből kiveszi az adott elem adott oszlopát
        if(isset($this->kosar->etlapsorok[$this->etelid][$attr]))
            {
            return($this->kosar->etlapsorok[$this->etelid][$attr]);
            }
         else
            {
            return("");
            }
        }
     
     function darabolas()
        { // ezt az ételt "darabolja", vagyis annyi "0"-s elemet csinál a kollegak tömmbe, ahány db van
        $this->kollegak=array();
        for($i=1; $i<=$this->db; $i++)
            {
            $this->kollegak[$i]=0;
            }
        }
     
     function setKollega($i,$id)
        {
        $this->kollegak[$i]=$id;
        }
    
     function getKollega($i)
        {
        return($this->kollegak[$i]);
        }
     
     function getSum()
        {// simán a darabszám * árral
        $this->sum=$this->db*$this->getAttr("Ar");
        return($this->sum);
        }
      
     function getSumKedvezmenyes()
        {
        foodDisCounter::reset();
        $this->addtoDisCounter();
        return(foodDisCounter::reszosszeg());
        }
        
     function addtoDisCounter()
        {
        if(is_null($this->kedvezmeny))
            {
            foodDisCounter::add($this);
            $this->kedvezmeny=foodDisCounter::getlast();
            }
        else
            {
            foodDisCounter::add($this,$this->kedvezmeny["tipus"],$this->kedvezmeny["ertek"]);
            }
        }
        
     function plusz($n)
        {
        if(!is_null($this->kosar->lastkedvezmeny))
            {
            $this->kedvezmeny=$this->kosar->lastkedvezmeny;
            }
        $this->db+=$n;
        return($this->db);
        }
     function minusz($n)
        {
        if($this->db-$n<0)
            {
            $this->db=0;
            }
        else
            {
            $this->db-=$n;
            }
        return($this->db);
        }
     function getDB()
        {
        return($this->db);
        }
        
    function saveToSESSION()
        {// kosarmuveletBox objektunot használ
        if($this->kosar->nev=="rendeles")
            {
            $kosarnev="rendeles";
            }
         if($this->kosar->nev=="lemondas")
            {
            $kosarnev="lemondas";
            } 
         $this->kosar->kosarmuvelet->muvelet(array("kosar" => $kosarnev, "op" => "plusz", "db" => $this->db, "etelid" => $this->etelid, "Ar" => $this->getAttr("Ar"), "datum" => $this->getAttr("datum") ));
        }
     
     function saveToDBASE($type)
        {
        if($this->kosar->nev=="rendeles")
            {
            $tipusjel=1;
            }
         if($this->kosar->nev=="lemondas")
            {
            $tipusjel=0;
            }   
        $aktualiscim=foodUser::getaktualiscim();
        $most=date("Y-m-d H:i:s");
       
        $stsave=basketDB::getSaveST($type);
       
        $stsave->bind_param("ssisiiisssdisisi",$this->kosar->rendelid["rendelid"],$aktualiscim["loginNev"],foodDatum::getNapsorszam($this->datum->key),foodDatum::getEv($this->datum->key),foodDatum::getHet($this->datum->key),$this->getDB(),$tipusjel,$most,$this->kategorianev,$this->datum->key,$this->getAttr("Ar"),$this->kedvezmeny["ertek"],$this->etelid,foodUser::getuserData("idlogin"),"",$this->kedvezmeny["tipus"]);
        $stsave->exec();
        $stkoll=basketDB::getKollST($type);
        foreach($this->kollegak as $sorszam => $kollegaid)
            {
            if($kollegaid!=0)
                {
                $stkoll->bind_param("isiii",$this->kosar->rendelid["rendelid"],$this->etelid,$kollegaid,$sorszam,0);
                $stkoll->exec();
                }
            }
        }
     
     function display($style,$dest,$attr)
        { // $this: referencia a kosár objektunhoz, style: RENDELES, LEMONDAS,USERMAIL, TXT, stb. , $dest: FLUSH vagy BUFFERRETURN, attr: átadandó attribútumok tömbje
        if($this->db>0 || SHOWNULL)
            {
            return(basketFoodDisplay::Show($this,$style,$dest,$attr));
            }
        else
            {
            return("");
            }
        }      
    }

class foodBasketWeek
    {
    public $kategoria;
    public $hetikategorianeve;
    public $kosar;
    public $Ar;
    public $db=0;
    public $sum;
    public $kollegak=array();
    public $datum;
    public $kedvezmeny=null;
    
    function __construct($kategoria,$Ar,$hetikategorianeve,$kosar)
        { // kategoria a kategoria "sima" neve (ahová a hetikategoria tartozik) , Ar: a heti ár, hetikategorianeve: pl. HM1 , kosar: refencia a kosár objektumhoz
        $this->kategoria=$kategoria;
        $this->hetikategorianeve=$hetikategorianeve;
        $this->kosar=$kosar;
        $this->Ar=$Ar;
        if(!is_null($this->kosar->lastkedvezmeny))
            {
            $this->kedvezmeny=$this->kosar->lastkedvezmeny;
            }
        }
    
     function display($style,$dest,$attr)
        {// egy "hetet" jelenít meg (pl. a HM1 -et) $this: referencia a kosár objektunhoz, style: RENDELES, LEMONDAS,USERMAIL, TXT, stb. , $dest: FLUSH vagy BUFFERRETURN, attr: átadandó attribútumok tömbje
         if($this->db>0 || SHOWNULL)
            {
            return(basketWeekFoodDisplay::Show($this,$style,$dest,$attr));
            }
         else
            {
            return("");
            }
        }
    
    function add($weekfood)
        { // foodBasketWeekFood -ot ad az itteni datum tömmbe
        if(!isset($this->datum[$weekfood->datum->key]))
            {
            $this->datum[$weekfood->datum->key]=$weekfood;
            }
        }
     
    function darabolas()
        {
        $this->kollegak=array();
        for($i=1; $i<=$this->db; $i++)
            {
            $this->kollegak[$i]=0;
            }
        }
        
    function setKollega($i,$id)
        {
        $this->kollegak[$i]=$id;
        }
    
    function getKollega($i)
        {
        return($this->kollegak[$i]);
        }
    
    function getSum()
        {
        $this->sum=$this->db*$this->Ar;
        return($this->sum);
        }
     function plusz($n)
        {
        if(!is_null($this->kosar->lastkedvezmeny))
            {
            $this->kedvezmeny=$this->kosar->lastkedvezmeny;
            }
        $this->db+=$n;
        return($this->db);
        }
     function minusz($n)
        {
        if($this->db-$n<0)
            {
            $this->db=0;
            }
        else
            {
            $this->db-=$n;
            }
        return($this->db);
        }
     function getDB()
        {
        return($this->db);
        }
      
    function getSumKedvezmenyes()
        {
        foodDisCounter::reset();
        $this->addtoDisCounter();
        return(foodDisCounter::reszosszeg());
        }
        
     function addtoDisCounter()
        {
        if(is_null($this->kedvezmeny))
            {
            foodDisCounter::add($this);
            $this->kedvezmeny=foodDisCounter::getlast();
            }
        else
            {
            foodDisCounter::add($this,$this->kedvezmeny["tipus"],$this->kedvezmeny["ertek"]);
            }
        }
    }
            
class foodBasketWeekFood extends foodBasketFood
    {
    public $hetikategorianev="";
    public $egeszhetre=true;
    public $week;

    function __construct($etelid,$db,$datum,$kosar,$hetikategorianev,$week)
        {// etelid: kategiriakod-eeee-hh-nn, db: darab, $datum: referencia a foodBasketDay objektumhoz, kosar: ref. a foodBasket -hez, PLUSZ: hetikategorianev pl. HM1, ez lesz a kategorianev, week: ref. a foodBasketWeek objektumhoz, amihez tartozik
        parent::__construct($etelid,$db,$datum,$kosar);
        $this->kategorianev=$this->getAttr("hetiKategoria");
        $this->hetikategorianev=$this->getAttr("Kategoria");
        $this->week=$week;
        $this->plusz($db);
        $week->add($this);
        }
    
    function saveToSESSION()
        {// kosarmuveletBox objektunot használ
        if($this->kosar->nev=="rendeles")
            {
            $kosarnev="rendeles";
            }
         if($this->kosar->nev=="lemondas")
            {
            $kosarnev="lemondas";
            } 

         $this->kosar->kosarmuvelet->addok=true;
         $this->kosar->kosarmuvelet->kosarnev=$kosarnev;
         $this->kosar->kosarmuvelet->pluszheti(array( "db" => $this->db, "etelid" => $this->etelid, "hetiAr" => $this->getAttr("hetiAr")));
        }
    
     function saveToDBASE($type)
        {
        if($this->kosar->nev=="rendeles")
            {
            $tipusjel=1;
            }
         if($this->kosar->nev=="lemondas")
            {
            $tipusjel=0;
            }   
        $aktualiscim=foodUser::getaktualiscim();
        $most=date("Y-m-d H:i:s");
        
        $stsave=basketDB::getSaveST($type);
        
        $stsave->bind_param("ssisiiisssdisisi",$this->kosar->rendelid["rendelid"],$aktualiscim["loginNev"],foodDatum::getNapsorszam($this->datum->key),foodDatum::getEv($this->datum->key),foodDatum::getHet($this->datum->key),$this->getDB(),$tipusjel,$most,$this->hetikategorianev,$this->datum->key,$this->week->Ar,$this->week->kedvezmeny["ertek"],$this->etelid,foodUser::getuserData("idlogin"),$this->kategorianev,$this->week->kedvezmeny["tipus"]);
        $stsave->exec();
        
        $stkoll=basketDB::getKollST($type);
        foreach($this->week->kollegak as $sorszam => $kollegaid)
            {
            if($kollegaid!=0)
                {
                $stkoll->bind_param("isiii",$this->kosar->rendelid["rendelid"],$this->etelid,$kollegaid,$sorszam,0);
                $stkoll->exec();
                }
            }
        }
    
    function getSum()
        {// a foodBasketWeek -ből veszi, ahová tartozik
        return($this->week->getSum());
        }
     function plusz($n)
        {
        if(!$this->kosar->addok)
            { // első alkalommal addok ("legfelső szinten", a kosár objektumban) false, így a héthez csak 1-szer adja hozzá
            $this->week->plusz($n); // továbbadja a foodBasketWeek -nek
            $this->kosar->addok=true;
            }
        if(!is_null($this->kosar->lastkedvezmeny))
            {
            $this->kedvezmeny=$this->kosar->lastkedvezmeny;
            }
        $this->db=$this->week->getDB(); // a hét objektumből ( foodBasketWeek ) veszi a darabszámot, amit visszaad
        return($this->db);
        }
     function minusz($n)
        {
        if(!$this->kosar->addok)
            {// első alkalommal addok ("legfelső szinten", a kosár objektumban) false, így a hétből csak 1-szer veszi el
            $this->week->minusz($n);
            $this->kosar->addok=true;
            }
        $this->db=$this->week->getDB(); // a hét objektumből ( foodBasketWeek ) veszi a darabszámot, amit visszaad
        return($this->getDB());
        }
        
     function getDB()
        {
        return($this->week->getDB());
        }
    }
 

 class basketDB
    {
    public static $qy_rendeles_save_new="";
    public static $qy_rendeles_save_temp="";
    public static $qy_kollega_save_new="";
    public static $qy_kollega_save_temp="";
    
    public static $st_rendeles_save_new=null;
    public static $st_rendeles_save_temp=null;
    public static $st_kollega_save_new=null;
    public static $st_kollega_save_temp=null;
    
    static function getSaveST($type)
        {
        if($type=="new")
            {
            if(self::$qy_rendeles_save_new=="")
                {
                $conn=foodDB::Connect();
                self::$qy_rendeles_save_new="insert into cardteszt_rendeles_new(rendelid, loginNev, napid, ev, het, db, type, ido, kategoria, datum, Ar, Kedvezmeny, etel_id, idlogin, hetiKategoria,Kedvezmenytipus) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
                self::$st_rendeles_save_new=$conn->prepare(self::$qy_rendeles_save_new);
                if(!self::$st_rendeles_save_new)
                    {
                    exit(ADATBAZISSZOVEG_FRONTEND."01");
                    }
                }
            return(self::$st_rendeles_save_new);
            }
            
        if($type=="temp")
            {
            if(self::$qy_rendeles_save_temp=="")
                {
                $conn=foodDB::Connect();
                self::$qy_rendeles_save_temp="insert into cardteszt_rendeles_temp(rendelid, loginNev, napid, ev, het, db, type, ido, kategoria, datum, Ar, Kedvezmeny, etel_id, idlogin, hetiKategoria,Kedvezmenytipus) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
                self::$st_rendeles_save_temp=$conn->prepare(self::$qy_rendeles_save_temp);
                if(!self::$st_rendeles_save_temp)
                    {
                    exit(ADATBAZISSZOVEG_FRONTEND."02");
                    }
                }
            return(self::$st_rendeles_save_temp);
            }    
        }
        
     static function getKollST($type)
        {
        if($type=="new")
            {
            if(self::$qy_kollega_save_new=="")
                {
                $conn=foodDB::Connect();
                self::$qy_kollega_save_new="insert into rendelesek_kinek(rendelid,etel_id,kollegaid,sorszam,tipus) values(?,?,?,?,?)";
                self::$st_kollega_save_new=$conn->prepare(self::$qy_kollega_save_new);
                if(!self::$st_kollega_save_new)
                    {
                    exit(ADATBAZISSZOVEG_FRONTEND."03");
                    }
                }
            return(self::$st_kollega_save_new);
            }
            
        if($type=="temp")
            {
            if(self::$qy_kollega_save_temp=="")
                {
                $conn=foodDB::Connect();
                self::$qy_kollega_save_temp="insert into rendelesek_kinek_temp(rendelid,etel_id,kollegaid,sorszam,tipus) values(?,?,?,?,?)";
                self::$st_kollega_save_temp=$conn->prepare(self::$qy_kollega_save_temp);
                if(!$st_kollega_save_temp)
                    {
                    exit(ADATBAZISSZOVEG_FRONTEND."04");
                    }
                }
            return(self::$st_kollega_save_temp);
            } 
        }

    }
?>