<?php
require_once("config.php");
require_once("foodinclude.php");
class foodXMLElement extends SimpleXMLElement
    {
    public $ev=null;
    public $het=null;
    public $evhet=null;
    
    function hiba($hiba,$kategoria,&$etlaphibak)
        {
        $etlaphibak["hiba"][$kategoria][]=$hiba;
        }
        
    function figyelmeztetes($figyelmeztetes,$kategoria,&$etlaphibak)
        {
        //$etlaphibak["figyelmeztetes"][$kategoria][]=$figyelmeztetes;
        $etlaphibak["hiba"][$kategoria][]=$figyelmeztetes;
        }
    
    function getEtlapXML($elsodatum,&$kategoriak,&$etlaphibak)
        {
        $this->getEvHet($etlaphibak);
        $this->getKategoriak($elsodatum,$kategoriak,$etlaphibak);
        }
    
    function getEvHet(&$etlaphibak)
        {
        if(isset($this->aktual->year) && isset($this->aktual->week))
            {
            $year=$this->getValue($this->aktual->year);
            $week=$this->getValue($this->aktual->week);
            if(is_numeric($year))
                {
                $ev=(int)$year;
                if($ev<date("Y",strtotime("-1 year")))
                    {
                    $this->figyelmeztetes("Túl régi étlap!","ALL",$etlaphibak);
                    }
                if($ev>date("Y",strtotime("+1 year")))
                    {
                    $this->figyelmeztetes($ev." évi étlap!","ALL",$etlaphibak);
                    }
                $this->ev=$ev;
                }
            else
                {
                $this->figyelmeztetes("Az év hibásan van megadva!","ALL",$etlaphibak);
                }
                
            if(is_numeric($week))
                {
                $het=(int)$week;
                if($het<0 || $het>53)
                    {
                    $this->figyelmeztetes("A hét hibásan van megadva!","ALL",$etlaphibak);
                    }
                $this->het=foodDatum::getHet($het);
                }
            else
                {
                $this->figyelmeztetes("A hét hibásan van megadva!","ALL",$etlaphibak);
                }    
           if(!is_null($this->ev) && !is_null($this->het))
                {
                $this->evhet=$this->ev.$this->het;
                }    
            }
        else
            {
            $this->figyelmeztetes("Az év vagy a hét nincs megadva!","ALL",$etlaphibak);
            }
        return($this->evhet);
        }
    
    function getKategoriak($elsodatum,&$kategoriak,&$etlaphibak)
        {
        if(!isset($this->menu1))
            {
            $this->hiba("Nincs étlap!","ALL",$etlaphibak);
            }
        else
            {
            for($i=1,$menusor="menu1"; isset($this->$menusor); $menusor="menu".(++$i))
                {
                if(!isset($this->$menusor->code))
                    {
                    $this->hiba("A(z) ".$i.". kategória nincs megadva!","ALL",$etlaphibak);
                    break;
                    }
                $kategoria=(string)trim($this->getValue($this->$menusor->code));
                
                if(!isset($this->$menusor->foods))
                    {
                    $this->figyelmeztetes("A(z) ".$kategoria." kategoriában nincsenek ételek!",$kategoria,$etlaphibak);
                    }
                else
                    {
                    for($j=1,$etel="food1", $datum=$elsodatum; $j<=7; $etel="food".(++$j), $datum=date("Y-m-d",strtotime($datum." +1 days")))
                        {
                        if(!isset($this->$menusor->foods->$etel))
                            {
                            $this->hiba("A(z) ".$kategoria." kategoriában a ".hetnapjai::$napok[foodLanguage::$deflang][$j]."i nap hiányzik!",$kategoria,$etlaphibak);
                            break 2;
                            }
                        else
                            {
                            // Nev, Ar, Info, Info2, Gomba
                            if(!isset($this->$menusor->foods->$etel->name))
                                {
                                $this->figyelmeztetes("A(z) ".$kategoria." kategoriában a ".hetnapjai::$napok[foodLanguage::$deflang][$j]."i napon az étel neve hiányzik!",$kategoria,$etlaphibak);
                                break 2;
                                }
                            else
                                {
                                $kategoriak[$kategoria][$datum]["Nev"]=$this->getValue($this->$menusor->foods->$etel->name);
                                }
                                
                            if(!isset($this->$menusor->foods->$etel->price))
                                {
                                $this->figyelmeztetes("A(z) ".$kategoria." kategoriában a ".hetnapjai::$napok[foodLanguage::$deflang][$j]."i napon az étel ára hiányzik!",$kategoria,$etlaphibak);
                                break 2;
                                }
                            else
                                {
                                $kategoriak[$kategoria][$datum]["Ar"]=$this->getValue($this->$menusor->foods->$etel->price);
                                $kategoriak[$kategoria][$datum]["Ar"]= str_replace(" Ft.","", $kategoriak[$kategoria][$datum]["Ar"]);
                                if(trim($kategoriak[$kategoria][$datum]["Ar"])=='')
                                    {
                                    $kategoriak[$kategoria][$datum]["Ar"]=0;
                                    }
                                }
                                
                            if(!isset($this->$menusor->foods->$etel->comm))
                                {
                                $this->figyelmeztetes("A(z) ".$kategoria." kategoriában a ".hetnapjai::$napok[foodLanguage::$deflang][$j]."i napon az étel Info-ja (comm) hiányzik!",$kategoria,$etlaphibak);
                                break 2;
                                }
                            else
                                {
                                $kategoriak[$kategoria][$datum]["Info"]=$this->getValue($this->$menusor->foods->$etel->comm);
                                }    
                                
                             if(!isset($this->$menusor->foods->$etel->desc))
                                {
                                $this->figyelmeztetes("A(z) ".$kategoria." kategoriában a ".hetnapjai::$napok[foodLanguage::$deflang][$j]."i napon az étel Info2-je (desc) hiányzik!",$etlaphibak);
                                break 2;
                                }
                            else
                                {
                                $kategoriak[$kategoria][$datum]["Info2"]=$this->getValue($this->$menusor->foods->$etel->desc);
                                $kategoriak[$kategoria][$datum]["Info2"]=$this->convplus($kategoriak[$kategoria][$datum]["Info2"]);
                                } 
                                
                            if(!isset($this->$menusor->foods->$etel->gomba))
                                {
                                $this->figyelmeztetes("A(z) ".$kategoria." kategoriában a ".hetnapjai::$napok[foodLanguage::$deflang][$j]."i napon az ételhez a Gomba (gomba) hiányzik!",$kategoria,$etlaphibak);
                                break 2;
                                }
                            else
                                {
                                $kategoriak[$kategoria][$datum]["Gomba"]=$this->getValue($this->$menusor->foods->$etel->gomba);
                                }     
                            // a többi...
                            
                            $kategoriak[$kategoria][$datum]["Het"]=foodDatum::getHet($datum);
                            $kategoriak[$kategoria][$datum]["Honap"]=foodDatum::getHonap($datum);
                            $kategoriak[$kategoria][$datum]["Nap"]=foodDatum::getNap($datum);
                            $kategoriak[$kategoria][$datum]["Kategoria"]=$kategoria;
                            $kategoriak[$kategoria][$datum]["ev"]=date("Y",strtotime($datum));
                            $kategoriak[$kategoria][$datum]["elozonap"]=0;
                            $kategoriak[$kategoria][$datum]["datum"]=$datum;
                            $kategoriak[$kategoria][$datum]["ssz"]=0;
                            $kategoriak[$kategoria][$datum]["heteve"]=foodDatum::getEv($datum);
                            $kategoriak[$kategoria][$datum]["hetiAr"]=0;
                            $kategoriak[$kategoria][$datum]["hetirendeles"]=0;
                            $kategoriak[$kategoria][$datum]["Szun"]="";
                            $kategoriak[$kategoria][$datum]["datum"]=$datum;
                            $kategoriak[$kategoria][$datum]["hetiKategoria"]="";
                            $kategoriak[$kategoria][$datum]["aktiv"]=1;
                            $kategoriak[$kategoria][$datum]["screenNev"]=$kategoriak[$kategoria][$datum]["Nev"];
                            $kategoriak[$kategoria][$datum]["lang"]=foodLanguage::getLang();
                            }
                        }
                    }
                }
            }
        
        }
    
    function convplus($str)
        {
        $vege="";
        while(($vege=substr($str,strlen($str)-3,3))=="[+]")
            {
            $str=substr($str,0,strlen($str)-3);
            }
        $str=str_replace("[+][+][+][+][+]"," - ",$str);
        $str=str_replace("[+][+][+][+]"," - ",$str);
        $str=str_replace("[+][+][+]"," - ",$str);
        $str=str_replace("[+][+]"," - ",$str);
        $str=str_replace("[+]"," - ",$str);
        
        while(($vege=substr($str,strlen($str)-1,1))=="-")
            {
            $str=substr($str,0,strlen($str)-1);
            }

        return($str);
        }

    function getValue($element)
        {
        $e=(string)$element;
        $mit=array("õ","û","Õ","Ũ");
        $mire=array("ő","ű","Ő","Ű");
        $e=str_replace($mit,$mire,$e);
        //$result = iconv('CP1252', 'UTF-8', $element);
        return($e);
        }
    }

?>