<?php
require_once("classes/interface_kedvezmeny_almodule.php");
class regisztracio_akcio_moduleBox extends foodModule implements kedvezmeny_almodule
    {
    public $sessionkey="regisztracio_akcio_module";
    public $hetek=array();
    public $akcioskedvezmeny=array();
    public $kedvezmenyek=array();
    public $akcionev="---";
    public $inited=false;
    
    function __construct($akcionev)
        {
        $this->akcionev=$akcionev;
        $conn=foodDB::Connect();
        $qyk="select id,ev,het,szazalek, ertek,szoveg from egyszeri_kedvezmeny where nev=? order by ev, het";
        
        $stk=$conn->prepare($qyk);
        if(!$stk)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        $stk->bind_param("s",$this->akcionev);
        $stk->exec();
        while($sor=$stk->fetch_assoc())
            {
            $this->hetek[$sor["ev"]][$sor["het"]]=$sor["id"];
            $this->kedvezmenyek[$sor["ev"]][$sor["het"]]=$sor["ertek"];
            }

        }
    /*    
    function getDatum($datum)
        {
        if(is_array($datum))
            {
            reset($datum);
            list($datumkey,$datumvalue)=each($datum);
            return($datumkey);
            }
        return($datum);
        }
     */
     
    function akcios($ev=null,$het=null)
        {
        if(is_null($ev))
            {
            if(!empty($this->akcioskedvezmeny))
                {
                return(true);
                }
            return(false);
            }
        if(!is_null($ev) && !is_null($het))
            {
            if(isset($this->akcioskedvezmeny[$ev][$het]))
                {
                return(true);
                }
            return(false);
            }
        return(false);
        }
     
    function getDatum($datum)
        {
        if(is_array($datum))
            {
            reset($datum);
            list($datumkey,$datumvalue)=each($datum);
            return($datumkey);
            }
        if(is_object($datum))
            {
            return($datum->key);
            }
        return($datum);
        }
     
    function getar($etel)
        {
        if(!$this->inited)
            {
            $this->init();
            }
        $ev=foodDatum::getEv($this->getDatum($etel->datum));
        $het=foodDatum::getHet($this->getDatum($etel->datum));

        if(isset($this->akcioskedvezmeny[$ev][$het]))
            {
            return(round($etel->getSum()*((100-$this->akcioskedvezmeny[$ev][$het])/100)));
            }
        else
            {
            return($etel->getSum());
            }
        }
    
    function process($etel)
        {
        if(!$this->inited)
            {
            $this->init();
            }
        $ev=foodDatum::getEv($this->getDatum($etel->datum));
        $het=foodDatum::getHet($this->getDatum($etel->datum));
        if(isset($this->akcioskedvezmeny[$ev][$het]))
            {
            $added=false;
            foreach(foodDisCounter::$elemek["szazalek"] as &$elem)
                {
                if($elem["mertek"]==$this->akcioskedvezmeny[$ev][$het])
                    {
                    $elem["arak"][]=array("ar" => $etel->getSum(), "db" => $etel->getDB());
                    $added=true;
                    }
                }
            unset($elem);
            if(!$added)
                {
                foodDisCounter::$elemek["szazalek"][]=array("mertek" => $this->akcioskedvezmeny[$ev][$het],"arak" => array( array("ar" => $etel->getSum(), "db" => $etel->getDB())));
                }
            $this->setlast(1,$this->akcioskedvezmeny[$ev][$het]);
            }
        else
            {
            foodDisCounter::$elemek["normal"][]=$etel->getSum();
            $this->setlast(0,0);
            }
        return(true);
        }
    function setlast($tipus,$ertek)
        { // $tipus: 0=semmi 1=szazalek 2=ertek
        foodDisCounter::setlast($tipus,$ertek);
        }
    
    
    function init()
        {
        $conn=foodDB::Connect();
        
        $qnext="select 1 from cardteszt_rendeles_new c where ev=? and het=? and idlogin=? and type=1";
        $stnext=$conn->prepare($qnext);
        if(!$stnext)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        
        $idlogin=foodUser::getUserData("idlogin");
        
        $qy="select e.ev, e.het, e.ertek from egyszeri_kedvezmeny e, egyszeri_kedvezmeny_jar j where e.id=j.egyszeri_kedvezmeny_id and j.idlogin=? order by e.ev,e.het";
        $st=$conn->prepare($qy);
        if(!$st)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        $st->bind_param("i",$idlogin);
        $st->exec();
        while($sor=$st->fetch_assoc())
            {
            $this->akcioskedvezmeny[$sor["ev"]][$sor["het"]]=$sor["ertek"];
            $stnext->bind_param("sii",$sor["ev"],$sor["het"],$idlogin);
            $stnext->exec();
            $sornext=$stnext->fetch_assoc();
            if($sornext)
                {
                $ujevhet=$this->get_next($sor["ev"],$sor["het"]);
                if($ujevhet)
                    {
                    $this->setKedvezmeny($ujevhet["ev"],$ujevhet["het"]);
                    }
                }
            }
        $this->inited=true;
        }
    
    function getSessionkey()
        {
        return($this->sessionkey);
        }
    
    function get_elsoHet()
        {
        list($elsoev,$hetek)=each($this->hetek);
        list($elsohet,$hetek)=each($hetek);
        $elsoevhet=array("ev" => $elsoev, "het" => $elsohet);
        return($elsoevhet);
        }
        
    function get_utolsoHet()
        {
        foreach($this->hetek as $ev => $hetek)
            {
            foreach($hetek as $het => $szazalek)
                {
                $utolsoev=$ev; $utolsohet=$het;
                }
            }
        $utolsoevhet=array("ev" => $utolsoev, "het" => $utolsohet);
        return($utolsoevhet);
        }
    
    function regisztracio($idlogin)
        {
        if(!$this->inited)
            {
            $this->init();
            }
        if(isset($_SESSION[$this->getSessionkey()]))
            {
            reset($this->hetek);
            list($elsoev,$hetek)=each($this->hetek);
            list($elsohet,$het)=each($hetek);
            $this->storeKedvezmeny($idlogin,$elsoev,$elsohet);
            }
        }
        
    function storeKedvezmeny($idlogin,$ev,$het)
        {
        $kedvezmeny_id=$this->hetek[$ev][$het];
        $conn=foodDB::Connect();
        $qy="insert ignore into egyszeri_kedvezmeny_jar( 	egyszeri_kedvezmeny_id,idlogin) values(?,?)";
        $st=$conn->prepare($qy);
        if(!$st)
            {
            exit(ADATBAZISHIBASZOVEG_FRONTEND);
            }
        $st->bind_param("ii",$kedvezmeny_id,$idlogin);
        $st->exec(); 
        $this->setKedvezmeny($ev,$het);
        }
     
    function setKedvezmeny($ev,$het)
        {
        $this->akcioskedvezmeny[$ev][$het]=$this->kedvezmenyek[$ev][$het];
        }
     
    function getKedvezmeny($ev,$het)
        {
        if(isset($this->akcioskedvezmeny[$ev][$het]))
            {
            return($this->akcioskedvezmeny[$ev][$het]);
            }
        else
            {
            return(0);
            }
        }
    
    function get_next_akcios($ex,$het)
        {
        
        }
    
    function get_next($ev,$het) 
        {
        if(isset($this->hetek[$ev][$het+1]))
            {
            $evhet=array("ev" => $ev, "het" => $het+1);
            return($evhet);
            }
        else
            {
            if(isset($this->hetek[$ev+1]))
                {
                reset($this->hetek[$ev+1]);
                list($nexthet,$kedvezmeny_id)=each($this->hetek[$ev+1]);
                $evhet=array("ev" => $ev+1, "het" => $nexthet);
                return($evhet);
                }
            else
                {
                return(false);
                }
            }
        }
    
    }


?>