<?php get_header(); ?>
<main class="row main">
	<p class="show-for-small-only maintitle">Blog</p>
	
	<div class="show-for-small-only column form-group">
		<a href="" class="button expanded border-red sidebar-toggle-button"><?php _e('Szűrők','Interfood'); ?></a>
	</div>
	
	<aside class="medium-4 medium-push-8 columns sidebar-toggle">
		<?php get_sidebar('blog'); ?>
	</aside>
	
	<section class="medium-8 medium-pull-4 columns">
		
		<?php if ( is_category() ) : ?>
		<h1 class="title-block">Kategória: <?php single_cat_title(); ?></h1>
		<?php endif; ?>
		<?php if ( is_tag() ) : ?>
		<h1 class="title-block">Címke: <?php single_tag_title(); ?></h1>
		<?php endif; ?>
		
		<?php
		$paged = ( get_query_var( 'paged' ) ) ? get_query_var( 'paged' ) : 1;
		
		if ( is_page('blog') ) :
			query_posts( array(
				'post_type' => 'post',
				'posts_per_page' => 2,
				'paged' => $paged
			) );
		endif;
		
		if ( have_posts() ) :
			while ( have_posts() ) : the_post(); ?>
			<article class="post-block list">
				
				<?php if ( has_post_thumbnail() ) : ?>
				<figure>
					<?php the_post_thumbnail(); ?>
				</figure>
				<?php endif; ?>
				
				<h3 class="title"><?php echo get_the_title(); ?></h3>
				
				<?php the_excerpt(); ?>
				
				<div class="row">
					<div class="large-9 medium-7 columns info">
						<ul class="list-comma text-color">
							<?php $categories = get_the_category();
							$separator = ', ';
							$output = '';
							if ( ! empty( $categories ) ) {
								foreach( $categories as $category ) {
									$output .= '<a href="' . esc_url( get_category_link( $category->term_id ) ) . '" alt="' . esc_attr( sprintf( __( 'View all posts in %s', 'textdomain' ), $category->name ) ) . '">' . esc_html( $category->name ) . '</a>' . $separator;
								}
								echo trim( $output, $separator );
							} ?>
						</ul>
						
						<time datetime="<?php echo get_the_date(); ?>"><?php echo get_the_date('Y. m. d.'); ?></time>
					</div>
					
					<div class="large-3 medium-5 small-8 small-offset-2 medium-offset-0 end columns">
						<a href="<?php the_permalink(); ?>" class="button expanded red"><?php _e('Tovább','Interfood'); ?></a>
					</div>
				</div>
			</article>
			<?php endwhile; ?>
			
			<?php
				$args = array(
					'prev_next' => false,
					'type' => 'list'
				);
				echo paginate_links($args);
			?>
			
			<?php /*
			<ul class="pagination">
				<li class="current">1</li>
				<li><a href="">2</a></li>
				<li><a href="">3</a></li>
				<li><a href="">4</a></li>
			</ul>
			*/ ?>
			
		<?php endif; ?>
		
	</section>
</main>
<?php
	get_template_part( 'inc/payment-desktop' );
	get_footer();
?>