<?php
add_theme_support( 'post-thumbnails' ); // Kiemelt képek engedélyezése
add_theme_support( 'menus' ); // Menü engedélyezése
add_filter('show_admin_bar', '__return_false'); // Admin sáv eltűntetése

// WordPress Login
function my_login_style() { ?>
    <style type="text/css">
        #login h1 a, .login h1 a {
            width: 215px;
            height: 102px;
            background-image: url(<?php echo get_stylesheet_directory_uri(); ?>/img/logo-login.png);
            background-size: 215px;
            padding-bottom: 30px;
        }
        body.login div#login form#loginform p.submit input#wp-submit {
            background: #019630;
            border: none;
            box-shadow: none;
            text-shadow: none;
        }
    </style>
<?php }
add_action( 'login_enqueue_scripts', 'my_login_style' );

// WPML Nyelvválasztó
function icl_post_languages(){
	$languages = icl_get_languages('skip_missing=1');
	if(1 < count($languages)){
		//echo __('This post is also available in: ');
        $img_folder_path = get_stylesheet_directory_uri();
		foreach($languages as $l){
			if(!$l['active']) $langs[] = '<li class="lang"><a href="'.$l['url'].'" class="'.$l['language_code'].'"><img src="'.$img_folder_path.'/img/flag-'.$l['language_code'].'.png" alt="">'.$l['native_name'].'</a></li>';
		}
		echo join(', ', $langs);
	}
}

// WPML Nyelvválasztó (mobil)
function icl_post_languages_mobile(){
	$languages = icl_get_languages('skip_missing=1');
	if(1 < count($languages)){
		//echo __('This post is also available in: ');
		foreach($languages as $l){
			if(!$l['active']) $langs[] = '<li class="lang '.$l['language_code'].'"><a href="'.$l['url'].'">'.$l['native_name'].'</a></li>';
		}
		echo join(', ', $langs);
	}
}

// ACF Options Page
if( function_exists('acf_add_options_page') ) {
    $args = array(
        'page_title' => 'Oldal beállítások'
    );
	acf_add_options_page($args);
}

?>