<?php
	// Template name: Kezdőoldal
	get_header();
?>
<section class="slideshow">
	
	<?php if ( have_rows('slider') ) : ?>
	<div class="sliders">
		<?php
		while ( have_rows('slider') ) : the_row();
		?>
		<article style="background: url('<?php the_sub_field('background'); ?>') center center">
			<div class="row caption">
				<?php
				if ( get_sub_field('slide_with_caption') ) :
				$caption = get_sub_field('caption');
				?>
				<img src="<?php echo $caption['url']; ?>" alt="<?php echo $caption['alt']; ?>" />
				<?php
				else :
				?>
				<h1 class="title"><?php the_sub_field('title'); ?></h1>
				<?php the_sub_field('headline');
				endif;
				?>
			</div>
		</article>
		<?php endwhile; ?>
	</div>
	<?php endif; ?>
	
	<div class="hide-for-small-only bottom">
		<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 100 100" version="1.1" preserveAspectRatio="none" fill="#eb1919">
			<path d="M0 100 100 100 100 0 0 55">
		</svg>
			
		<div class="inner">
			<div class="row column">
				<a href="<?php echo get_the_permalink(icl_object_id(91,'post')) ?>" class="more"><span><?php echo get_the_title(icl_object_id(91,'post')) ?></span></a>
			</div>
		</div>
	</div>
	
</section>

<a href="<?php echo get_the_permalink(icl_object_id(91,'post')) ?>" class="show-for-small-only order-bar">
	<span><?php echo get_the_title(icl_object_id(91,'post')) ?></span>
</a>

<main class="row main">
	<section class="large-9 columns">
		<h2 class="headline"><div><div class="border-animate"></div><span><?php echo get_the_title(icl_object_id(109,'post')) ?></span></div></h2>
		
		<?php
		$featured_news = get_field('featured_news');
		if ( $featured_news ) :
        $db = 0;
		?>
		<div class="row" data-equalizer="current">
			<?php foreach ( $featured_news as $post) : setup_postdata($post); ?>
            <?php $db++; ?>
			<article class="medium-4 columns article-block wow fadeInDown <?php echo $db; ?>" data-wow-duration="1s" data-wow-delay="0.<?php echo 2*$db; ?>s">
				<h3 class="maintitle" data-equalizer-watch="current"><?php the_title(); ?></h3>
				<figure>
					<?php if ( has_post_thumbnail() ) : ?>
					<a href="<?php the_permalink(); ?>">
						<?php the_post_thumbnail( array(305,218) ); ?>
					</a>
					<?php endif; ?>
					<?php if ( get_field('label') ) : ?>
					<strong class="figure-label"><?php the_field('label'); ?></strong>
					<?php endif; ?>
				</figure>
				<?php if ( get_field('prologue') ) : ?>
				<div class="text-highlighted">
					<p><?php echo wp_trim_words( get_field('prologue'), $num_words = 9, $more = null ); ?></p>
				</div>
				<?php endif; ?>
				<div class="hide-for-small-only text-small">
					<?php echo wp_trim_words( get_the_excerpt(), $num_words = 14, $more = null ); ?>
				</div>
			</article>
			<?php endforeach; wp_reset_postdata(); ?>
		</div>
		<?php endif; ?>
		
		<?php
		$featured_news_slider = get_field('featured_news_slider');
		if ( $featured_news_slider ) :
        $feature_db = 0;
		?>
			<?php foreach ( $featured_news_slider as $post) : setup_postdata($post); ?>
            <?php $feature_db++; ?>
			<article class="article-block no-border wow <?php if($feature_db%2==0) { echo 'fadeInRight';} else { echo 'fadeInLeft'; } ?>" data-wow-delay="0.1s">
				<h3 class="maintitle"><?php the_title(); ?></h3>
				
				<figure class="figure-caption">
					<a href="<?php the_permalink(); ?>">
						<?php if ( has_post_thumbnail() ) :
							the_post_thumbnail();
						endif; ?>
						<?php if ( get_field('label') ) : ?>
						<figcaption><span><?php the_field('label'); ?></span></figcaption>
						<?php endif; ?>
					</a>
				</figure>
				<?php if ( get_field('prologue') ) : ?>
				<div class="text-highlighted">
					<p><?php echo wp_trim_words( get_field('prologue'), $num_words = 36, $more = null ); ?></p>
				</div>
				<?php endif; ?>
				<div class="hide-for-small-only">
					<?php the_excerpt(); ?>
				</div>
			</article>
			<?php endforeach; wp_reset_postdata(); ?>
		<?php endif; ?>
		
		<a href="<?php echo get_the_permalink(icl_object_id(91,'post')) ?>" class="show-for-small-only order-bar">
			<span><?php echo get_the_title(icl_object_id(91,'post')) ?></span>
		</a>
		
		<?php if ( have_rows('offer') ) : ?>
        <?php $db = 0; ?>
		<hr class="hide-for-small-only" />
		<h3 class="maintitle">Ajánlatunk</h3>
		<div class="row food-slider">
			<?php
			while ( have_rows('offer') ) : the_row();
			$image = get_sub_field('image');
            $db++;
			?>
            <div id="item<?php echo $db; ?>" class="slide-item">
                <div id="name<?php echo $db; ?>" class="slide-name">
                    <a href="<?php the_sub_field('url'); ?>" class="block">
                        <figure>
                            <img src="<?php echo $image['url']; ?>" alt="<?php echo $image['alt'] ?>" />
                        </figure>
                        <h4><?php the_sub_field('name'); ?></h4>
                    </a>
                </div>
            </div>
			
			<?php endwhile; ?>
		</div>
		<?php endif; ?>
		
		<div class="row">
			<?php if ( get_field('facebook','option') ) { ?>
			<div class="medium-6 columns social-box">
				<div class="fb-page" data-href="<?php the_field('facebook','option'); ?>" data-width="450" data-small-header="false" data-adapt-container-width="true" data-hide-cover="false" data-show-facepile="true"><blockquote cite="https://www.facebook.com/interfood" class="fb-xfbml-parse-ignore"><a href="https://www.facebook.com/interfood">Interfood</a></blockquote></div>
			</div>
			<?php } ?>
			<div class="hide-for-small-only medium-6 columns social-box">
				<div class="g-page" data-width="300" data-href="https://plus.google.com/118059313230472945846" data-showtagline="false" data-showcoverphoto="false" data-rel="publisher"></div>
			</div>
		</div>
	</section>
	
	<aside class="large-3 columns" id="sidebar">
		<?php get_sidebar(); ?>
	</aside>
</main>

<?php get_template_part( 'inc/payment-desktop' ); ?>
<?php get_template_part( 'inc/payment-mobile' ); ?>

<a href="<?php echo get_the_permalink(icl_object_id(91,'post')) ?>" class="show-for-small-only order-bar">
	<span><?php echo get_the_title(icl_object_id(91,'post')) ?></span>
</a>
<?php get_footer(); ?>